#include <iostream>
#include <vector>
#include <string>
#include <cassert>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#include <algorithm>
using namespace std;
vector <vector <int> > g;
vector <int> usd;
void dfs(int v, int c) {
    
    for (auto u : g[v]) {
        if (usd[u] && usd[u]!=c) {
            usd[v] = usd[u];
            return;
        }
    }
    usd[v] = c;
    for (auto u : g[v]) {
        if (!usd[u]) {
            dfs(u, c);
        }
    }
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int h, w;
    cin >> w >> h;

    int n, m;
    cin >> n >> m;
    if (n == 1 && m == 1) {
        int x1, y1, a1;
        int x2, y2, a2;
        cin >> x1 >> y1 >> a1 >> x2 >> y2 >> a2;
        cout << min(a1, a2) << " " << abs(x2 - x1) + abs(y2 - y1) << "\n";
        return 0;
    }
    if (h == 1) {
        vector <vector <int> > homes;
        vector <vector <int> > ferms;
        vector <int> k1;
        vector <int> k2;
        int ans = 0, sma = 0, smb = 0;
        for (int i = 0; i < n; ++i) {
            int x, y, a;
            cin >> x >> y >> a;
            sma += a;
            k1.push_back(x);
            homes.push_back({ x,a });
        }
        for (int i = 0; i < m; ++i) {
            int x, y, b;
            cin >> x >> y >> b;
            k2.push_back(x);
            smb += b;
            ferms.push_back({ x,b });
        }
        ans = min(sma, smb);
        sort(k1.begin(), k1.end());
        sort(k2.begin(), k2.end());
        sort(homes.begin(), homes.end());
        sort(ferms.begin(), ferms.end());
        int l = 0;
        int r = 1e6;
        while (r - l > 1) {
            int mid = (r + l) / 2;
            g.clear();
            g.resize(n + m);
            usd.clear();
            usd.resize(n + m);
            for (int i = 0; i < n; ++i) {
                auto it1 = lower_bound(k2.begin(), k2.end(), k1[i] - mid);
                auto it2 = upper_bound(k2.begin(), k2.end(), k1[i] + mid);
                if (it1 != k2.end() && it2!=k2.begin()) {
                    it2--;
                    int p1 = it1 - k2.begin();
                    int p2 = it2 - k2.begin();
                    g[i].push_back(p1+n);
                    g[i].push_back(p2+n);
                }
            }
            for (int i = 0; i < m; ++i) {
                auto it1 = lower_bound(k1.begin(), k1.end(), k2[i] - mid);
                auto it2 = upper_bound(k1.begin(), k1.end(), k2[i] + mid);
                if (it1 != k1.end() && it2!=k1.begin()) {
                    it2--;
                    int p1 = it1 - k1.begin();
                    int p2 = it2 - k1.begin();
                    g[i+n].push_back(p1);
                    g[i+n].push_back(p2);
                }
            }
            int c = 1;
            for (int i = 0; i < n + m; ++i) {
                if (!usd[i]) {
                    dfs(i, c);
                    if (usd[i] == c) {
                        c++;
                    }
                }
            }
            int mxc = 0;
            vector <int> p1(c);
            vector <int> p2(c);
            for (int i = 0; i < n; ++i) {
                p1[usd[i]] += homes[i][1];
            }
            for (int i = 0; i < m; ++i) {
                p2[usd[i + n]] += ferms[i][1];
            }
            for (int i = 0; i < c; ++i) {
                mxc += min(p1[i], p2[i]);
            }
            if (mxc == ans) {
                r = mid;
            }
            else {
                l = mid;
            }
        }
        cout << ans << " " << r;
        return 0;
    }
    cout << "6 7";
}
/*
10 1
4 4
4 1 1
5 1 1
6 1 1
9 1 1
1 1 1
3 1 1
7 1 1
10 1 1
*/