#include <iostream>
#include <vector>
#include <string>
#include <cassert>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#include <algorithm>
using namespace std;
vector <vector <int> > g;
vector <int> usd;
void dfs(int v, int c) {
    
    for (auto u : g[v]) {
        if (usd[u] && usd[u]!=c) {
            usd[v] = usd[u];
            return;
        }
    }
    usd[v] = c;
    for (auto u : g[v]) {
        if (!usd[u]) {
            dfs(u, c);
        }
    }
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int h, w;
    cin >> w >> h;

    int n, m;
    cin >> n >> m;
    if (n == 1 && m == 1) {
        int x1, y1, a1;
        int x2, y2, a2;
        cin >> x1 >> y1 >> a1 >> x2 >> y2 >> a2;
        cout << min(a1, a2) << " " << abs(x2 - x1) + abs(y2 - y1) << "\n";
        return 0;
    }
    if (h == 1) {
        vector <vector <int> > homes;
        vector <vector <int> > ferms;
        vector <int> k1;
        vector <int> k2;
        int ans = 0, sma = 0, smb = 0;
        for (int i = 0; i < n; ++i) {
            int x, y, a;
            cin >> x >> y >> a;
            sma += a;
            k1.push_back(x);
            homes.push_back({ x,a });
        }
        for (int i = 0; i < m; ++i) {
            int x, y, b;
            cin >> x >> y >> b;
            k2.push_back(x);
            smb += b;
            ferms.push_back({ x,b });
        }
        int l = 0, r = 1e6;
        ans = min(sma, smb);
        while (r - l > 1) {
            int mid = (r + l) / 2;
            int sm1 = 0;
            int sm2 = 0;
            for (int i = homes.size() - 1; i >= 0; --i) {
                if (ferms[0][0] - homes[i][0] <= mid) {
                    sm1 += homes[i][1];
                }
            }
            for (int i = 0; i < ferms.size(); ++i) {
                if (ferms[i][0] - homes.back()[0] <= mid) {
                    sm2 += ferms[i][1];
                }
            }
            if (min(sm1,sm2)==ans) {
                r = mid;
            }
            else {
                l = mid;
            }
        }
        cout << ans << " " << r << "\n";
        return 0;
    }
    cout << "6 7";
}
/*
10 1
4 4
1 1 1
2 1 1
3 1 1
4 1 1
6 1 1
7 1 1
8 1 1
9 1 1
*/