#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("tune=native")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll N = 2e5, INF = 1e18;

struct E {
    ll q, x, i, f;
};

bool operator<(const E &a, const E &b) {
    if (a.x != b.x) return a.x < b.x;
    if (a.f != b.f) return a.f;
    return 0;
}

int main() {
#ifndef AVEVAD
    //cin.tie(0);
    //ios_base::sync_with_stdio(0);
#endif
    ll n, m;
    cin >> n >> m;
    vector<pair<ll, ll>> a0(n), a1(n);
    vector<pair<ll, ll>> b(m);
    vector<E> v;
    for (ll i = 0; i < n; i++) {
        ll fl, fr, sl, sr;
        cin >> fl >> fr >> sl >> sr;
        fl--, sl--;
        a0[i] = {fl, fr};
        a1[i] = {sl, sr};
        v.push_back({0, fl, i, 0});
        v.push_back({0, fr, i, 1});
        v.push_back({1, sl, i, 0});
        v.push_back({1, sr, i, 1});
    }
    for (ll j = 0; j < m; j++) {
        ll l, r;
        cin >> l >> r;
        l--;
        b[j] = {l, r};
        v.push_back({2, l, j, 0});
        v.push_back({2, r, j, 1});
    }
    sort(v.begin(), v.end());
    vector<set<ll>> s0(n), s1(n);
    {
        ll i0 = -1, i1 = -1, j = -1;
        for (auto e : v) {
            if (e.q == 2) {
                if (e.f == 0) {
                    j = e.i;
                    if (i0 != -1) s0[i0].insert(j);
                    if (i1 != -1) s1[i1].insert(j);
                } else j = -1;
            } else {
                if (e.f == 0) {
                    (e.q ? i1 : i0) = e.i;
                    if (j != -1) (e.q ? s1 : s0)[e.i].insert(j);
                } else (e.q ? i1 : i0) = -1;
            }
        }
    }
    for (ll i = 0; i < n; i++) {
        for (auto it = s0[i].begin(); it != s0[i].end();) {
            if (s1[i].find(*it) != s1[i].end()) {
                s1[i].erase(*it);
                it = s0[i].erase(it);
            } else it++;
        }
    }
    ll cnt_free = 0;
    {
        vector<ll> w(m);
        for (ll i = 0; i < n; i++) {
            for (ll j : s0[i]) w[j] = 1;
            for (ll j : s1[i]) w[j] = 1;
        }
        for (ll j = 0; j < m; j++) if (!w[j]) cnt_free++;
    }
    ll ans = 0;
    for (ll i = 0; i < n; i++) ans += max(s0[i].size(), s1[i].size());
    ans += cnt_free;
    cout << ans << '\n';
    return 0;
}
