#include<bits/stdc++.h>

#define int long long
#define f first
#define s second
#define vec vector
#define pb push_back
#define sz(x) (int)(x).size()
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define all(x) (x).begin(), (x).end()
#define ld long double
#define pii pair<int, int>

using namespace std;
const int MAXN = 1e5 + 2;
const int INF = 1e9;

signed main()
{
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
    int n;
    cin >> n;

    vec<vec<int>> g (MAXN);
    for(int i = 2; i < MAXN; i++)
    {
        int mx = 1;
        for(int x = 2; x * x <= i; x++)
        {
            if(i % x == 0)
            {
                mx = i / x;
                break;
            }
        }

        g[i].pb(mx);
        g[mx].pb(i);
    }

    auto BFS = [&](int st, int fn)
    {
        set<pii> q;
        vec<int> d (MAXN, -INF);
        d[st] = st;
        q.insert({d[st], st});

        while(sz(q))
        {
            auto it = q.begin();
            //it--;
            int v = it->s;
            q.erase({d[v], v});
           // cout << v << endl;

            for(auto u : g[v])
            {
                if(d[u] < min(d[v], u))
                {
                    q.erase({d[u], u});
                    d[u] = min(d[v], u);
                    q.insert({d[u], u});
                }
            }
        }

        return d[fn];
    };

    FOR(i, n)
    {
        int a, b;
        cin >> a >> b;

        int x = BFS(a, b);
        if(x == -INF)
            cout << -1 << endl;
        else
            cout << x << endl;
    }
}


