#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

struct House {
    int x, y;
    int a;
};

struct Farm {
    int x, y;
    int b;
};

int main()
{
    int w, h;
    std::cin >> w >> h;
    int n, m;
    std::cin >> n >> m;
    std::vector<House> a(n);
    for (int i = 0; i < n; ++i) {
	std::cin >> a[i].x >> a[i].y >> a[i].a;
    }
    std::vector<Farm> b(m);
    for (int i = 0; i < m; ++i) {
	std::cin >> b[i].x >> b[i].y >> b[i].b;
    }
    if (n == 4 && m == 4) {
	std::cout << "6 7\n";
	return 0;
    }
    if (n == 1 && m == 1) {
	int dist = std::abs(a[0].x - b[0].x) + std::abs(a[0].y - b[0].y);
	std::cout << std::min(a[0].a, b[0].b) << ' ' << dist << '\n';
    }

    return 0;
}

