#include "bits/stdc++.h"
using namespace std;

#define rep(i, a, b) for (int (i) = a; (i) < (b); ++(i))
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

template<typename T1, typename T2>
bool ckmin(T1& a, const T2& b) {
    return a > b && (a = b, true);
}

template<typename T1, typename T2>
bool ckmax(T1& a, const T2& b) {
    return a < b && (a = b, true);
}

constexpr int MAXC = 1e5 + 1;
vi pr;
int sp[MAXC];

void linear() {
    rep(i, 2, MAXC) {
        if (sp[i] == 0) sp[i] = i, pr.push_back(i);
        for (auto p: pr) {
            if (p > sp[i] || i*p >= MAXC) break;
            sp[i * p] = p;
        }
    }
}

void solve(int test) {
    int a, b;
    cin >> a >> b;

    int ans = gcd(a, b), d = b / ans;
    while (d > 1) {
        if (sp[d] > sp[ans]) {
            cout << "1\n";
            return;
        }
        d /= sp[d];
    }
    cout << ans << '\n';
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(ios::failbit);

    linear();
    
    int T;
    cin >> T;
    rep(test, 1, T + 1) solve(test);
}