#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <cmath>

typedef long long ll;

#define all(x) (x).begin(), (x).end()
#define pb(x) push_back(x)

using namespace std;

vector<ll> gr[200001];
bool u[200001];

bool dfs_get_w(ll v, ll& f, vector<ll>& w, ll pr) {
    if (v == f) {
        w.pb(v);
        return true;
    }
    for (auto elem : gr[v]) {
        if (elem != pr && !u[elem]) {
            if (dfs_get_w(elem, f, w, v)) {
                w.pb(v);
                return true;
            }
        }
    }
    return false;
}

void dfs_get_l(ll v, ll& max_r, ll& max_el, ll d, ll pr) {
    if (d > max_r) {
        max_r = d;
        max_el = v;
    }
    for (auto elem : gr[v]) {
        if (!u[elem] && elem != pr) {
            dfs_get_l(elem, max_r, max_el, d + 1, v);
        }
    }

}

vector<ll> get_l(ll an) {
    ll max_r = 0;
    ll max_el = an;

    dfs_get_l(an, max_r, max_el, 0, -1);

    an = max_el;
    max_r = 0;

    dfs_get_l(an, max_r, max_el, 0, -1);

    vector<ll> w;

    dfs_get_w(an, max_el, w, -1);

    return w;

}

int main() {

    //ios_base::sync_with_stdio(false);
    // cin.tie(NULL);

    int n; cin >> n;

    ll u_, v;
    for (int i = 0; i < n - 1; ++i) {
        cin >> u_ >> v;
        gr[v - 1].push_back(u_ - 1);
        gr[u_ - 1].push_back(v - 1);
    }

    vector<ll> w = get_l(1);

    bool f = false;

    while (!f && w.size() != 1) {
        ll m = w.size() / 2;

        ll m_l = w[m];
        cout << m_l + 1 << endl;
        u[m_l] = true;
        ll an; cin >> an;

        if (an == 0) { cout << '!' << ' ' << an; f = true; continue; }

        --an;
        w = get_l(an);

    }
    if (!f) cout << '!' << ' ' << w[0] + 1;

    return 0;
}
