#include<iostream>
#include <vector>
#include <string>
#include <math.h>
#include <algorithm>
#include <set>
#include <map>
using namespace std;
typedef long long ll;

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	ll n, m, q; cin >> n >> m >> q;
	ll ans = 0;
	map<pair<ll, ll>, ll> w;
	while (q--) {
		ll l, r; cin >> l >> r; --l, --r;
		ll l1 = l, r1 = r;
		ll a = (l + m - 1) / m;
		ll b = r / m;
		if (a < b) {
			ans += b - a;
			r = a * m - 1;
			l = l1;
			if (l <= r) {
				l = l % m;
				r = r % m;
				if (l > r) {
					w[{ l, 1 }] ++;
					w[{ 0, 1 }]++;
					w[{ m, 0 }]++;
					w[{ r + 1, 0 }]++;
				}
				else {
					w[{ l, 1 }]++;
					w[{ r + 1, 0 }]++;
				}
			}
			r = r1;
			l = b * m;
			if (l <= r) {
				l = l % m;
				r = r % m;
				if (l > r) {
					w[{ l, 1 }] ++;
					w[{ 0, 1 }]++;
					w[{ m, 0 }]++;
					w[{ r + 1, 0 }]++;
				}
				else {
					w[{ l, 1 }]++;
					w[{ r + 1, 0 }]++;
				}
			}
		}
		else if (a == b) {
			r = a * m - 1;
			l = l1;
			if (l <= r) {
				l = l % m;
				r = r % m;
				if (l > r) {
					w[{ l, 1 }] ++;
					w[{ 0, 1 }]++;
					w[{ m, 0 }]++;
					w[{ r + 1, 0 }]++;
				}
				else {
					w[{ l, 1 }]++;
					w[{ r + 1, 0 }]++;
				}
			}
			r = r1;
			l = b * m;
			if (l <= r) {
				l = l % m;
				r = r % m;
				if (l > r) {
					w[{ l, 1 }] ++;
					w[{ 0, 1 }]++;
					w[{ m, 0 }]++;
					w[{ r + 1, 0 }]++;
				}
				else {
					w[{ l, 1 }]++;
					w[{ r + 1, 0 }]++;
				}
			}
		}
		else {
			l = l1 % m;
			r = r1 % m;
			if (l > r) {
				w[{ l, 1 }]++;
				w[{ 0, 1 }]++;
				w[{ m, 0 }]++;
				w[{ r + 1, 0 }]++;
			}
			else {
				w[{ l, 1 }]++;
				w[{ r + 1, 0 }]++;
			}
		}
	}
	ll res = 1e18, now = 0;
	map<ll, ll> mp;
	for (auto& i : w) {
		if (i.first.second) {
			now += i.second;
			mp[i.first.first] = max(mp[i.first.first], now);
		}
		else {
			now -= i.second;
			mp[i.first.first] = max(mp[i.first.first], now);
		}
	}
	mp.erase(m);
	for (auto& i : mp) res = min(res, i.second);
	cout << res + ans;
}