#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <string>
#include <deque>
#include <algorithm>
#include <iomanip>
#include <unordered_map>
#include <cmath>

using namespace std;

typedef long long ll;
const ll inf = 1e9;



int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);

	int n, m, q;
	cin >> n >> m >> q;
	vector <ll> v(2*m + 1);
	for (int i = 0; i != q; i++) {
		int l, r;
		cin >> l >> r;
		l %= m;
		r %= m;
		if (r > l) {
			v[r + 1] -= 1;
			v[l]++;
		}
		else {
			r += m;
			v[r + 1] -= 1;
			v[l]++;
		}
	}
	ll sum = 0;
	for (ll& i : v) {
		sum += i;
		i = sum;
	}
	for (int i = 0; i != m; i++) {
		v[i] += v[i + m];
	}
	v[2 * m] = inf;
	ll ans = inf;
	for (ll i : v) ans = min(ans, i);
	cout << ans;
}