#include <bits/stdc++.h>

using namespace std;

#define fi(n) for (int i = 0; i < n; i++)
#define all(ls) ls.begin(), ls.end()

typedef long long ll;
typedef vector<ll> vi;

ll gcd(ll a, ll b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

ll max_fact(ll n) {
    ll i = 2;
    ll ans;
    while (i * i <= n) {
        if (n % i == 0) {
            return (n / i);
        }
        i++;
    }
    return 1;
}

void solve() {
    ll a, b;
    cin >> a >> b;
    while (true) {
        if (gcd(a, b) == 1) {
            cout << 1 << '\n';
            return;
        }
        ll min_ans = min(a, b);
        if (a == b || max_fact(a) == b || max_fact(b) == a) {
            cout << min_ans << '\n';
            return;
        }
        if (a >= b) {
            a = max_fact(a);
        } else {
            b = max_fact(b);
        }
    }

}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll t; cin >> t;
    fi(t) {
        solve();
    }
}