#pragma comment(linker, "/STACK:130000000")
#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <queue>
#include <unordered_set>
using namespace std;

inline void start() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
}

const int N = 1e4;
vector<int> prime;
bool notPrime[N];
unordered_set<long long> q;

void f() {
	for(int i = 2; i < N; i++)
		if (!notPrime[i]) {
			prime.push_back(i);
			for (int j = i * i; j < N; j += i)
				notPrime[j] = 1;
		}
}

long long dfs(long long v, int k, long long res, long long ans) {
	q.insert(v);
	if (v == res)
		return ans;
	for (int i = k; i >= 0; i--)
		if (1e18 / prime[i] > v && q.find(v * prime[i]) == q.end())
			ans = max(ans, dfs(v * prime[i], i, res, ans));
	return 1;
}

int main() {
	start();
	f();
	int t;
	cin >> t;
	while (t--) {
		q.clear();
		int a, b;
		cin >> a >> b;
		if (a > b)
			swap(a, b);
		int k = prime.size();
		for(int i = 0; i < prime.size(); i++)
			if (a % prime[i] == 0) {
				k = i;
				break;
			}
		cout << dfs(a, k, b, a) << '\n';
	}
	return 0;
}