#include <iostream>
#include "vector"

using namespace std;
vector<vector<int>> tree;
vector<int> p;
vector<int> the_depthest;
vector<bool> used;
vector<int> depth;
vector<vector<int>> bin_up;

pair<int, int> dfs(int root, int depth_num = 0) {
    used[root] = true;
    depth_num+=1;
    depth[root]=depth_num;
    int max_depth = depth_num;
    int v = root;
    for (auto to:tree[root]) {
        if (!used[to]) {
            p[to]=root;
            auto go = dfs(to, depth_num);
            if (go.first > max_depth) {
                max_depth = go.first;
                v = go.second;
            }
        }

    }
    the_depthest[root] = v;
    return {max_depth, v};
}
vector<int>ans;
int ask(int root){
    if (ans[root]!=-1){
        return ans[root];
    }
    cout<<root+1<<endl;
    int ss;
    cin>>ss;
    ans[root]=ss;
    ss--;
    if (ss==-1){
        cout<<"! "<<root;
        exit(0);
    }
    return ss;
}
int get_ans(int root){
    int v=the_depthest[root];
    int i=0;
    while (depth[bin_up[v][i]]>depth[ask(bin_up[v][i])]){
        i++;
    }
    return get_ans(ask(bin_up[root][i]));
}
void f() {
    ios::sync_with_stdio(false);
    cin.tie(false);
}
int main() {
    int n;
    int max_log = 20;
    cin >> n;
    used.resize(n);
    tree.resize(n);
    ans.resize(n,-1);
    p.resize(n);
    depth.resize(n);
    the_depthest.resize(n);
    for (int i = 0; i < n-1; ++i) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        if (l > r) {
            swap(l, r);
        }
        tree[l].emplace_back(r);
        tree[r].emplace_back(l);
    }
    dfs(0);
    bin_up.resize(n, vector<int>(max_log));
    for (int log = 0; log < n; ++log) {
        for (int i = 0; i < n; ++i) {
            if (log == 0)
                bin_up[i][log] = p[i];
            else {
                bin_up[i][log] = bin_up[bin_up[i][log - 1]][log - 1];
            }
        }
    }
    get_ans(0);
    return 0;
}
