#include <iostream>
#include "vector"

using namespace std;
vector<vector<int>> tree;
vector<int> p;
vector<int> the_depthest;
vector<bool> used;
vector<int> depth;
vector<int> asss;
vector<bool> used2;
bool flag = false;

void dfs(int root, int time = 0) {
    used[root] = true;
    asss[time] = root;
    time++;
    for (auto to:tree[root]) {
        if (!used[to])
            dfs(to, time);
    }
}

int mem = 0;

void dfs_max_time(int root) {
    if (flag)
        return;
    used2[root] = true;
    mem = root;
    for (auto to:tree[root]) {
        if (!used2[to])
            dfs_max_time(to);
    }
    flag = true;
}

void f() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
}

int ask(int root) {
    cout << root + 1 << endl;
    int ans;
    cin >> ans;
    ans--;
    if (ans == -1) {
        cout << "! " << root + 1 << endl;
        exit(0);
    }
    return ans;
}

bool check(int root) {
    if (ask(asss[root]) == asss[root - 1])
        return false;
    return true;
}

int main() {
    int n;
    int max_log = 20;
    cin >> n;
    used2.resize(n);
    asss.resize(n);
    used.resize(n);
    tree.resize(n);
    p.resize(n);
    depth.resize(n);
    the_depthest.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        if (l > r) {
            swap(l, r);
        }
        tree[l].emplace_back(r);
        tree[r].emplace_back(l);
    }
    if (n > 20) {
        dfs_max_time(0);
        dfs(mem);
        int l, r;
        l = 0;
        r = n - 1;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (check(m)) {
                l = m;
            } else {
                r = m;
            }
        }
        ask(asss[l]);
        ask(asss[r]);
        return 0;
    }else{
        int x=0;
        while (true)
            x=ask(x);
    }
}
/*
10
 1 2
 2 3
 3 4
 4 5
 5 6
 6 7
 7 8
 8 9
 9 10

 */