#include <iostream>
#include <vector>
#include <set>
#include "algorithm"

using namespace std;

int main() {
    vector<pair<int, int>> scanline;
    int n, m, q;
    int ans = 0;
    scanline.emplace_back(0, 0);
    cin >> n >> m >> q;
    for (int i = 0; i < q; ++i) {
        int l, r;
        cin >> l >> r;
        if ((r - l + 1) / m != 0) {
            ans += (r - l + 1) / m;
            l += (r - l + 1) / m * m;
            if (l > r)
                continue;
        }
        l--;
        r--;
        l %= m;
        r %= m;
        if (r != 0) {
            scanline.emplace_back(r - 1, 0);
        }
        if (l != 0) {
            scanline.emplace_back(l - 1, 0);
        }
        if (r != m - 1) {
            scanline.emplace_back(r + 1, 0);
        }
        if (l != m - 1) {
            scanline.emplace_back(l + 1, 0);
        }

        if (l <= r) {
            scanline.emplace_back(l, -1);
            scanline.emplace_back(r, 1);
        } else {
            scanline.emplace_back(l, -1);
            scanline.emplace_back(m - 1, 1);
            scanline.emplace_back(0, -1);
            scanline.emplace_back(r, 1);
        }
    }
    for (int i = 0; i < m; ++i) {
        scanline.emplace_back(i, 0);
    }
    sort(scanline.begin(), scanline.end());
    int zxc = 1e9 + 1;
    int now = 0;
    int minn = scanline[0].first;
    int last_time = -1;
    for (auto &i : scanline) {
        int time = i.first;
        int type = i.second;
        if (type == 1) {
            now--;
        }
        if (type == 0) {
            zxc = min(now, zxc);
        }
        if (type == -1) {
            now++;
        }
    }
    if (minn != 0) {
        zxc = 0;
    }
    if (zxc == int(1e9 + 1))
        zxc = 0;
    cout << zxc + ans;
    return 0;
}
