#include <bits/stdc++.h>
#define int long long
#ifdef LOCAL
#   define debug(x) cout << #x << " = " << (x) << endl
#else
#   define debug(x)
#endif

typedef long long ll;
typedef long double ld;
using namespace std;


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m; cin >> n >> m;

    vector<int> vec = {-1};

    int fl[n], fr[n], sl[n], sr[n];
    for (int i = 0; i < n; i++) {
        cin >> fl[i] >> fr[i] >> sl[i] >> sr[i];
        vec.push_back(fl[i]);
        vec.push_back(fr[i]);
        vec.push_back(sl[i]);
        vec.push_back(sr[i]);

    }

    int l[m], r[m];
    for (int i = 0; i < m; i++) {
        cin >> l[i] >> r[i];
        vec.push_back(l[i]);
        vec.push_back(r[i]);
    }

    sort(vec.begin(), vec.end());
    vec.resize(unique(vec.begin(), vec.end()) - vec.begin());

    unordered_map<int, int> unicode;
    for (int i = 0; i < (int)vec.size(); i++) {
        unicode[vec[i]] = i;
    }

    for (int i = 0; i < n; i++) {
        fl[i] = unicode[fl[i]];
        fr[i] = unicode[fr[i]];
        sl[i] = unicode[sl[i]];
        sr[i] = unicode[sr[i]];
    }

    for (int i = 0; i < m; i++) {
        l[i] = unicode[l[i]];
        r[i] = unicode[r[i]];
    }

    int sz = (int)unicode.size();
    int p[sz]{};

    for (int i = 0; i < m; i++) {
        p[l[i]] += 1;
        if (r[i] != sz - 1) p[r[i] + 1] -= 1;
    }

    for (int i = 1; i < sz; i++) {
        p[i] += p[i - 1];
    }

    for (int i = 1; i < sz; i++) {
        p[i] += p[i - 1];
    }

    int ans = 0;
    for (int i = 0; i < n; i++) {
        int suml = p[fr[i]] - p[fl[i] - 1];
        int sumr = p[sr[i]] - p[sl[i] - 1];
        ans += max(suml, sumr);
    }
    cout << ans;
    return 0;
}