#include <bits/stdc++.h>
#define int long long
#ifdef LOCAL
#   define debug(x) cout << #x << " = " << (x) << endl
#else
#   define debug(x)
#endif

typedef long long ll;
typedef long double ld;
using namespace std;

vector<int> g[200500];
vector<int> lists;

int tin[200500];
int tout[200500];
int parent[200500];
int timer = 0;

void dfs(int u, int p = -1) {
    tin[u] = timer++;
    parent[u] = p;
    auto it = std::find(g[u].begin(), g[u].end(), p);
    if (it != g[u].end()) g[u].erase(it);

    if (g[u].empty()) lists.push_back(u);

    for (int& v : g[u]) {
        dfs(v, u);
    }
    tout[u] = timer++;
}

bool is_parent(int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

unordered_map<int, int> quests;
int get(int u) {
    if (quests.find(u) != quests.end()) {
        return quests[u];
    }
    cout << u << endl;
    int v; cin >> v;

    if (v == 0) {
        cout << "! " << u << endl;
        exit(0);
    }
    else {
        quests[u] = v;
        return v;
    }
}

void find(int u) {
    int l = 0, r = (int)g[u].size() - 1;
    while (r - l > 2) {
        int m1 = l + (r - l) / 3;
        int m2 = r - (r - l) / 3;
        if (is_parent(g[u][m1], get(g[u][m1]))) {
            r = m2;
        }
        else {
            l = m1;
        }
    }
    for (int v = l; v <= r; v++) {
        if (is_parent(g[u][v], get(g[u][v]))) {
            find(g[u][v]);
            return;
        }
    }
}

vector<int> eee;
unordered_map<int, int> num;
int nummm = 0;
void dfs2(int u, int p = -1) {
    eee.push_back(u);
    num[u] = nummm++;
    for (int v : g[u]) {
        if (v != p) {
            dfs2(v, u);
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n; cin >> n;
    for (int i = 1; i < n; i++) {
        int u, v; cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    bool ggg = true;
    for (int i = 1; i <= n; i++) {
        ggg &= (g[i].size() <= 2);
    }

    if (ggg) {
        int v = 1;
        for (int i = 1; i <= n; i++) {
            if (g[i].size() == 1) {
                v = i;
            }
        }
        dfs2(v);

        int l = 0, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (num[get(eee[m])] >= num[eee[m]]) l = m;
            else r = m;
        }
        get(eee[l]);
        return 0;
    }

    dfs(1);
    get(1);
    find(1);

    return 0;
}