#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <deque>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e18;
const ld EPS = 1e-9;
const ll MOD = 1000000000 + 7;
const ld PI = acos(-1);

struct O {
	ll l, r;
	void input() {
		cin >> l >> r;
	}
};

bool peresek(O a, O b) {
	return min(a.r, b.r) >= max(a.l, b.l);
}

struct O1 {
	O a, b;
	void input() {
		a.input();
		b.input();
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n, m;
	cin >> n >> m;
	vector<O> b(m);
	vector<O1> a(n);
	vector<ll> la(n);
	for (ll i = 0; i < n; i++) {
		a[i].input();
		la[i] = a[i].a.l;
	}
	for (ll i = 0; i < m; i++) b[i].input();
	vector<pair<ll, ll>> s(n, { 0, 0 });
	vector<ll> s1(n, 0);
	for (ll i = 0; i < m; i++) {
		ll j = upper_bound(la.begin(), la.end(), b[i].l) - la.begin();
		if (j == 0) {
			s[0].first++;
			s[0].second++;
			continue;
		}
		j--;
		if (peresek(b[i], a[j].a) && peresek(b[i], a[j].b)) continue;
		if (j + 1 == n || !peresek(b[i], a[j + 1].a)) {
			if (!peresek(b[i], a[j].a) && !peresek(b[i], a[j].b)) {
				s[0].first++;
				s[0].second++;
			}
			else if (!peresek(b[i], a[j].a)) s[j].first++;
			else s[j].second++;
			continue;
		}
		if (peresek(b[i], a[j + 1].a) && peresek(b[i], a[j + 1].b)) continue;
		s1[j + 1]++;
	}
	vector<pair<ll, ll>> dp(n);
	dp[0] = s[0];
	for (ll i = 1; i < n; i++) {
		dp[i].first = max(dp[i - 1].first, dp[i - 1].second) + s[i].first;
		dp[i].second = max(dp[i - 1].second + s[i].second, dp[i - 1].first + s[i].second + s1[i]);
	}
	cout << max(dp[n - 1].first, dp[n - 1].second) << "\n";
	return 0;
}