#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <random>

using namespace std;

typedef long long ll;

mt19937 rnd('r' + 'o' + 'b' + 'i' + 'v' + 'i' + 'r' + 't');

// #define int ll

vector<int> t;

void update(int v, int l, int r, int idx, int x) {
	if (l + 1 == r) {
		t[v] = x;
		return;
	}
	int mid = (l + r) / 2;
	if (idx < mid) {
		update(2 * v + 1, l, mid, idx, x);
	}
	else {
		update(2 * v + 2, mid, r, idx, x);
	}
	t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

int get_max(int v, int l, int r, int a, int b) {
	if (b <= l || r <= a) {
		return 0;
	}
	if (a <= l && r <= b) {
		return t[v];
	}
	int mid = (l + r) / 2;
	return max(get_max(2 * v + 1, l, mid, a, b), get_max(2 * v + 2, mid, r, a, b));
}

int solve(int n, int m, vector<pair<pair<int, int>, pair<int, int>>> arr, vector<pair<int, int>> bbb) {
	vector<pair<int, int>> aaa;
	int gg = 0;
	for (int i = 0; i < m; i++) {
		int x, y;
		x = bbb[i].first, y = bbb[i].second;
		int l = -1, r = n;
		while (l + 1 < r) {
			int mid = (l + r) / 2;
			if (arr[mid].first.second >= x) {
				r = mid;
			}
			else {
				l = mid;
			}
		}
		if (r == n || arr[r].second.first > y) {
			bool flag = true;
			for (int j = 0; j < n; j++) {
				if (arr[j].first.second < x && y < arr[j].second.first) {
					flag = false;
				}
				if (true) {
					if (j == 0 && arr[j].first.first > y) {
						flag = false;
					}
					else if (j != 0 && arr[j].first.first > y && arr[j - 1].second.second < x) {
						flag = false;
					}
				}
				if (true) {
					if (j == n - 1 && arr[j].second.second < x) {
						flag = false;
					}
				}
			}
			if (flag) {
				aaa.push_back({ x, y });
			}
			else {
				gg++;
			}
		}
	}

	/*for (auto el : aaa) {
		cout << '?' << el.first << ' ' << el.second << '\n';
	} */
	m = aaa.size();
	if (m == 0) {
		return gg;
	}
	t.clear();
	t.resize(4 * m);
	arr.insert(arr.begin(), { {-2, -2}, {-1, -1} });
	int j = 0;
	n++;
	vector<int> dp(m);
	for (int i = 0; i < m; i++) {
		int x = aaa[i].first, y = aaa[i].second;
		while (j + 1 < n && arr[j + 1].second.second < x) {
			j++;
		}
		if (j + 1 == n) {
			if (i == 0) {
				dp[i] = 1;
			}
			else {
				dp[i] = get_max(0, 0, m, 0, i) + 1;
			}
		}
		else {
			if (max(x, arr[j + 1].first.first) <= min(y, arr[j + 1].first.second)) {
				if (i == 0) {
					dp[i] = 1;
				}
				else {
					dp[i] = get_max(0, 0, m, 0, i) + 1;
				}
			}
			else {
				int l = -1, r = i;
				while (l + 1 < r) {
					int mid = (l + r) / 2;
					if (max(aaa[mid].first, arr[j + 1].second.first) <= min(aaa[mid].second, arr[j + 1].second.second)) {
						r = mid;
					}
					else {
						l = mid;
					}
				}
				int ff = i - r + 1;

				l = -1, r = i;
				while (l + 1 < r) {
					int mid = (l + r) / 2;
					if (arr[j + 1].first.first > aaa[mid].second) {
						l = mid;
					}
					else {
						r = mid;
					}
				}
				if (l == -1) {
					dp[i] = ff;
				} else {
					dp[i] = get_max(0, 0, m, 0, l + 1) + ff;
				}
			}
		}
		update(0, 0, m, i, dp[i]);
	}
	/*for (int i = 0; i < m; i++) {
		cout << dp[i] << ' ';
	}
	cout << '\n';*/
	return *max_element(dp.begin(), dp.end()) + gg;
}

int solve1(int n, int m, vector<pair<pair<int, int>, pair<int, int>>> arr, vector<pair<int, int>> bbb) {
	int ans = 0;
	for (int mask = 0; mask < (1 << m); mask++) {
		vector<pair<bool, bool>> used(n);
		int cnt = 0;
		for (int i = 0; i < m; i++) {
			if ((1 << i) & mask) {
				cnt++;
				for (int j = 0; j < n; j++) {
					if (max(arr[j].first.first, bbb[i].first) <= min(arr[j].first.second, bbb[i].second)) {
						used[j].first = true;
					}
					if (max(arr[j].second.first, bbb[i].first) <= min(arr[j].second.second, bbb[i].second)) {
						used[j].second = true;
					}
				}
			}
		}
		bool flag = true;
		for (int i = 0; i < n; i++) {
			if (used[i].first && used[i].second) {
				flag = false;
			}
		}
		if (flag) {
			ans = max(ans, cnt);
		}
	}
	return ans;
}

signed main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	// pole chudes

	/*while (true) {
		int n = rnd() % 3 + 1, m = rnd() % 3 + 1;
		vector<pair<pair<int, int>, pair<int, int>>> arr(n);
		int eee = 10;
		for (int i = 0; i < n; i++) {
			if (i == 0) {
				arr[i].first.first = rnd() % eee;
				arr[i].first.second = rnd() % (eee + 1 - arr[i].first.first) + arr[i].first.first;

				arr[i].second.first = rnd() % (eee + 2 - arr[i].first.second - 1) + arr[i].first.second + 1;
				arr[i].second.second = rnd() % (eee + 3 - arr[i].second.first) + arr[i].second.first;

				arr[i].first.first++;
				arr[i].first.second++;
				arr[i].second.first++;
				arr[i].second.second++;
			}
			else {
				arr[i].first.first = rnd() % (eee - arr[i - 1].second.second - 1) + arr[i - 1].second.second + 1;
				arr[i].first.second = rnd() % (eee + 1 - arr[i].first.first) + arr[i].first.first;

				arr[i].second.first = rnd() % (eee + 2 - arr[i].first.second - 1) + arr[i].first.second + 1;
				arr[i].second.second = rnd() % (eee + 3 - arr[i].second.first) + arr[i].second.first;

				arr[i].first.first++;
				arr[i].first.second++;
				arr[i].second.first++;
				arr[i].second.second++;
			}
			eee += 5;
		}
		vector<pair<int, int>> b(m);
		eee = 10;
		for (int i = 0; i < m; i++) {
			if (i == 0) {
				b[i].first = rnd() % eee;
				b[i].second = rnd() % (eee - b[i].first) + b[i].first;
				b[i].first++;
				b[i].second++;
			}
			else {
				b[i].first = rnd() % (eee - b[i - 1].second - 1) + b[i - 1].second + 1;
				b[i].second = rnd() % (eee - b[i].first) + b[i].first;
				b[i].first++;
				b[i].second++;
			}
			eee += 4;
		}
		if (solve(n, m, arr, b) != solve1(n, m, arr, b)) {
			cout << n << ' ' << m << '\n';
			for (auto el : arr) {
				cout << el.first.first << ' ' << el.first.second << ' ' << el.second.first << ' ' << el.second.second << '\n';
			}
			for (auto el : b) {
				cout << el.first << ' ' << el.second << '\n';
			}
			return 0;
		}
	}*/
	int n, m;
	cin >> n >> m;
	vector<pair<pair<int, int>, pair<int, int>>> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i].first.first >> arr[i].first.second >> arr[i].second.first >> arr[i].second.second;
	}
	vector<pair<int, int>> bbb(m);
	for (int i = 0; i < m; i++) {
		cin >> bbb[i].first >> bbb[i].second;
	}
	cout << solve(n, m, arr, bbb) << '\n';
	// cout << solve1(n, m, arr, bbb) << '\n';

	return 0;
}