#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <random>

using namespace std;

typedef long long ll;

mt19937 rnd('r' + 'o' + 'b' + 'i' + 'v' + 'i' + 'r' + 't');

// #define int ll

const int maxn = (int)1e7;

struct Node {
	int val = 0;

	Node* l = nullptr, * r = nullptr;

	Node() {

	}
};

void update(Node* v, int l, int r, int a, int b, int x) {
	if (b <= l || r <= a) {
		return;
	}
	if (a <= l && r <= b) {
		v->val += x;
		return;
	}
	int mid = (l + r) / 2;
	v->l = new Node();
	v->r = new Node();
	update(v->l, l, mid, a, b, x);
	update(v->r, mid, r, a, b, x);
}

int get_min(Node* v) {
	if (v == nullptr) {
		return 0;
	}
	return min(get_min(v->l), get_min(v->r)) + v->val;
}


signed main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	// lada racing

	int n, m, q;
	cin >> n >> m >> q;
	Node* root = new Node();
	for (int i = 0; i < q; i++) {
		ll l, r;
		cin >> l >> r;
		l--, r--;
		if (l - l % m + m - 1 >= r) {
			update(root, 0, m, l, r + 1, 1);
		} else {
			update(root, 0, m, l, m, 1);
			l = l - l % m + m;
			update(root, 0, m, 0, r, 1);
			r = r - r % m - 1;
			if (l <= r) {
				update(root, 0, m, 0, m, (r - l + 1) / m);
			}
		}
	}

	cout << get_min(root) << '\n';
	/*int n, m;
	cin >> n >> m;
	vector<pair<pair<int, int>, pair<int, int>>> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i].first.first >> arr[i].first.second >> arr[i].second.first >>arr[i].second.second;
	}
	vector<pair<int, int>> aaa;
	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		int l = -1, r = n;
		while (l + 1 < r) {
			int mid = (l + r) / 2;
			if (arr[mid].first.second >= x) {
				r = mid;
			}
			else {
				l = mid;
			}
		}
		if (r == n || arr[r].second.first > y) {
			aaa.push_back({ x, y });
		}
	}
	m = aaa.size();
	for (int i = 0; i < m; ++i) {
		
	}*/


	return 0;
}