#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <deque>
#include <cmath>
#include <cassert>
#include <queue>

using namespace std;
typedef long long ll;

int n;
vector <int> g[200010];
bool used[200010];
int was[200010];
int C = 1;
int d[200010];

void dfs(int u)
{
	if (used[u]) return;
	if (was[u] == C) return;

	was[u] = C;

	for (auto v : g[u])
	{
		if (!used[v] && was[v] != C) d[v] = d[u] + 1;
		dfs(v);
	}
}

int s = 1;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;
	for (int i = 0; i < n - 1; ++i)
	{
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}

	while (true)
	{
		for (int i = 1; i <= n; ++i) d[i] = 0;
		++C;
		d[s] = 1;
		dfs(s);
		int u = max_element(d + 1, d + 1 + n) - d;

		for (int i = 1; i <= n; ++i) d[i] = 0;
		++C;
		d[u] = 1;
		dfs(u);

		int len = *(max_element(d + 1, d + 1 + n));
		int nd = (len + 1) / 2;
		int q;
		for (int i = 1; i <= n; ++i) if (d[i] == nd)
		{
			q = i;
			break;
		}

		cout << q << endl;
		int gt;
		cin >> gt;
		if (gt == 0)
		{
			cout << "! " << q << endl;
			return 0;
		}
		used[q] = true;
		s = gt;
	}

	return 0;
}