#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <deque>
#include <cmath>
#include <cassert>
#include <queue>

using namespace std;
typedef long long ll;

vector <int> divs(int n)
{
	vector <int>ans;
	for (int d = 2; d * d <= n; ++d)
	{
		while (n % d == 0)
		{
			n /= d;
			ans.push_back(d);
		}
	}
	if (n > 1) ans.push_back(n);
	return ans;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--)
	{
		int x, y;
		cin >> x >> y;
		auto a = divs(x);
		auto b = divs(y);
		int i = a.size() - 1;
		int j = b.size() - 1;
		int ans = 1;
		while (i >= 0 && j >= 0 && a[i] == b[j])
		{
			ans *=	 a[i];
			--i;
			--j;
		}
		cout << ans << '\n';
	}

	return 0;
}