#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <deque>
#include <cmath>
#include <cassert>
#include <queue>

using namespace std;
typedef long long ll;

const int A = 10000010;
int d[A];
int md[A];
int pre[A];

vector <int> p;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	for (int i = 2; i < A; ++i)
	{
		if (!d[i])
		{
			d[i] = md[i] = i;
			p.push_back(i);
		}
		for (int j = 0; j < p.size() && p[j] <= d[i] && (ll)p[j] * i < A; ++j)
		{
			d[p[j] * i] = p[j];
			md[p[j] * i] = md[i];
			pre[p[j] * i] = p[j] * i / md[i];
		}
	}


	int t;
	cin >> t;
	while (t--)
	{
		int x, y;
		cin >> x >> y;
		int ans = 1;
		while (x > 1 && y > 1 && md[x] == md[y])
		{
			ans *= md[x];
			x = pre[x];
			y = pre[y];
		}
		cout << ans << '\n';
	}

	return 0;
}