#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <deque>
#include <cmath>
#include <cassert>
#include <queue>
#include <unordered_set>
#include <unordered_map>

using namespace std;
typedef long long ll;

int n, k, A;
string s[10010];
unordered_map<string, int> cnt[20];
unordered_map<string, map <char, int>> diff[20][20];
string all;

string er(string s, int j)
{
	return s.substr(0, j) + s.substr(j + 1, k - j - 1);
}

string er(string s, int i, int j)
{
	if (i > j) swap(i, j);
	return s.substr(0, i) + s.substr(i + 1, j - i - 1) + s.substr(j + 1, k - j - 1);
}

bool ishere(const string& s)
{
	for (int j = 0; j < k; ++j)
	{
		string f = er(s, j);
		if (cnt[j][f]) return true;
	}
	return false;
}


signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> k >> A;
	cin >> all;

	for (int i = 1; i <= n; ++i)
	{
		cin >> s[i];
		for (int j = 0; j < k; ++j)
		{
			string f = er(s[i], j);
			cnt[j][f]++;
		}

		for (int x = 0; x < k; ++x)
		{
			for (int y = 0; y < k; ++y)
			{
				diff[x][y][er(s[i], x, y)][s[i][y]]++;
			}
		}
	}

	for (int i = 1; i <= n; ++i)
	{
		for (int j = 0; j < k; ++j)
		{
			string f = er(s[i], j);
			cnt[j][f]--;
			for (int x = 0; x < k; ++x)
			{
				for (int y = 0; y < k; ++y)
				{
					if (--diff[x][y][er(s[i], x, y)][s[i][y]] == 0) diff[x][y][er(s[i], x, y)].erase(s[i][y]);
				}
			}
		}

		int ans = (A - 1) * k + 1;
		string sam;

		//1

		bool fnd = false;
		for (int x = 0; x < k; ++x)
		{
			if (cnt[x][er(s[i], x)])
			{
				fnd = true;
				break;
			}
		}
		ans -= fnd;
		if (!fnd) sam = s[i];

		//2, 3

		for (int x = 0; x < k; ++x)
		{
			auto cp = er(s[i], x);

			//int mi = diff[x][cp].size() - diff[x][cp].count(s[i][x]);
			//ans -= mi;

			//if (sam.empty() && mi != k - 1)
			//{
			//	for (auto cha : all)
			//	{
			//		if (!diff[x][cp].count(cha) && cha != s[i][x])
			//		{
			//			sam = s[i];
			//			sam[x] = cha;
			//			break;
			//		}
			//	}
			//}

			if (cnt[x][cp])
			{
				ans -= A - 1;
			}
			else if (sam.empty() && k > 1)
			{
				for (auto cha : all)
				{
					if (cha != s[i][x])
					{
						sam = s[i];
						sam[x] = cha;
						break;
					}
				}
			}
		}

		//4

		for (int x = 0; x < k; ++x)
		{
			for (int y = 0; y < k; ++y) if (x != y)
			{
				if (!cnt[y][er(s[i], y)])
					ans -= diff[x][y][er(s[i], x, y)].size() - diff[x][y][er(s[i], x, y)].count(s[i][y]);
			}
		}

		cout << ans << ' ' << sam << '\n';


		for (int j = 0; j < k; ++j)
		{
			string f = er(s[i], j);
			cnt[j][f]++;
			for (int x = 0; x < k; ++x)
			{
				for (int y = 0; y < k; ++y)
				{
					diff[x][y][er(s[i], x, y)][s[i][y]]++;
				}
			}

		}
	}
	return 0;
}