#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <deque>
#include <cmath>
#include <cassert>
#include <queue>
#include <unordered_set>
#include <unordered_map>

using namespace std;
typedef long long ll;

int n, k, A;
string s[10010];
unordered_map<string, int> cnt[20];
unordered_map<string, map <char, int>> diff[20][20];
string all;

string er(string s, int j)
{
	return s.substr(0, j) + s.substr(j + 1, k - j - 1);
}

string er(string s, int i, int j)
{
	if (i > j) swap(i, j);
	return s.substr(0, i) + s.substr(i + 1, j - i - 1) + s.substr(j + 1, k - j - 1);
}

bool ishere(const string& s)
{
	for (int j = 0; j < k; ++j)
	{
		string f = er(s, j);
		if (cnt[j][f]) return true;
	}
	return false;
}


signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> k >> A;
	cin >> all;

	for (int i = 1; i <= n; ++i)
	{
		cin >> s[i];
		/*s[i].resize(k);
		for (auto& j : s[i]) j = all[rand() % k];
		cout << s[i] << '\n';*/
		for (int j = 0; j < k; ++j)
		{
			string f = er(s[i], j);
			cnt[j][f]++;
		}

		for (int x = 0; x < k; ++x)
		{
			for (int y = 0; y < k; ++y)
			{
				diff[x][y][er(s[i], x, y)][s[i][y]]++;
			}
		}
	}

	for (int i = 1; i <= n; ++i)
	{
		for (int j = 0; j < k; ++j)
		{
			string f = er(s[i], j);
			cnt[j][f]--;
			for (int x = 0; x < k; ++x)
			{
				for (int y = 0; y < k; ++y)
				{
					if (--diff[x][y][er(s[i], x, y)][s[i][y]] == 0) diff[x][y][er(s[i], x, y)].erase(s[i][y]);
				}
			}
		}

		int ans = (A - 1) * k + 1;
		string sam;

		//1

		bool fnd = false;
		for (int x = 0; x < k; ++x)
		{
			if (cnt[x][er(s[i], x)])
			{
				fnd = true;
				break;
			}
		}
		ans -= fnd;
		if (!fnd) sam = s[i];

		//2, 3

		for (int y = 0; y < k; ++y)
		{
			auto cp = er(s[i], y);

			if (cnt[y][cp])
			{
				ans -= A - 1;
			}
			else
			{
				set <char> di;
				for (int x = 0; x < k; ++x) if (x != y)
				{
					for (auto u : diff[x][y][er(s[i], x, y)]) di.insert(u.first);
							
				}

				int mi = di.size() - di.count(s[i][y]);
				ans -= mi;
				if (mi < A - 1 && sam.empty())
				{
					for (auto cha : all) if (cha != s[i][y])
					{
						if (!di.count(cha))
						{
							sam = s[i];
							sam[y] = cha;
							break;
						}
					}
				}
			}
		}

		cout << ans << ' ' << sam << '\n';

		//string samp;
		//int ans1 = 0;

		//if (!ishere(s[i]))
		//{
		//	samp = s[i];
		//	++ans1;
		//}

		//for (int j = 0; j < k; ++j)
		//{
		//	for (auto c : all) if (c != s[i][j])
		//	{
		//		string cp = s[i];
		//		cp[j] = c;
		//		if (!ishere(cp))
		//		{
		//			++ans1;
		//			if (samp.empty()) samp = cp;
		//		}
		//	}
		//}

		//if (ans != ans1)
		//{
		//	assert(false);
		//}


		for (int j = 0; j < k; ++j)
		{
			string f = er(s[i], j);
			cnt[j][f]++;
			for (int x = 0; x < k; ++x)
			{
				for (int y = 0; y < k; ++y)
				{
					diff[x][y][er(s[i], x, y)][s[i][y]]++;
				}
			}

		}
	}
	return 0;
}