#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <queue>
#include <random>
#include <bitset>
#include <algorithm>

#define ll long long
#define ld long double
#define int ll

using namespace std;

mt19937 rnd;

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    int q;
    cin >> q;
    int ans = 0;
    vector<pair<int, int>>a;
    set<int>b;
    b.insert(0);
    b.insert(m - 1);
    map<int, int>mp;
    for (int i = 0; i < q; ++i) {
        int l, r;
        cin >> l >> r;
        l -= 1;
        ans += (r - l) / m;
        l %= m;
        r %= m;
        if (r == l) continue;
        if (r == 0) r = m;
        if (l < r) {
            a.push_back({ l, r - 1 });
            mp[l] += 1;
            mp[r] -= 1;
        }
        else {
            mp[l] += 1;
            mp[0] += 1;
            mp[r] -= 1;
            mp[m] -= 1;
            a.push_back({ l, m - 1 });
            a.push_back({ 0, r - 1 });
        }
        b.insert(l);
        if (r < m - 1) b.insert(r);
    }
    sort(a.begin(), a.end());
    int ans1 = 1e9;
    if (a.size() == 0 || a[0].first != 0) ans1 = 0;
    int t = 0;
    int inds = 0;
    int indf = 0;
    for (auto it = b.begin(); it != b.end(); ++it) {
        int i = *it;
        t += mp[i];
        ans1 = min(ans1, t);
    }
    cout << ans + ans1;
    return 0;
}
