#include<iostream>
#include<vector>
#include<algorithm>
#include<map>
using namespace std;
vector<int> g[200000];
bool used[200000];
int last = -1;
int count1 = 0;
map<int, int> m, m1;
void dfs(int v) {
	used[v] = true;
	last = v;
	for (auto u : g[v]) {
		if (!used[u]) {
			dfs(u);
		}
	}
}
void dfs1(int v) {
	used[v] = true;
	m[count1] = v;
	m1[v] = count1;
	count1++;
	for (auto u : g[v]) {
		if (!used[u]) {
			dfs1(u);
		}
	}
}
int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, w, u;
	cin >> n;
	for (int i = 0; i < n - 1; i++) {
		cin >> w >> u;
		w--; u--;
		g[w].push_back(u);
		g[u].push_back(w);
	}
	if (n <= 20) {
		cout << 1 << endl;
		int x;
		cin >> x;
		int pref = 1;
		while (x != 0) {
			cout << x << endl;
			pref = x;
			cin >> x;
		}
		cout << "! " << pref << endl;
		exit(0);
	}
	vector<int> start;
	for (int i = 0; i < n; i++) {
		if (g[i].size() == 1) {
			last = i;
		}
	}
	fill(used, used + n, false);
	dfs1(start[0]);
	int l = 0, r = n, x;
	while (r - l > 0) {
		int mid = (r + l) / 2;
		cout << m[mid] + 1 << endl;
		cin >> x;
		if (x == 0) {
			cout << "! " << m[mid] + 1 << endl;
			exit(0);
		}
		x--;
		if (m1[x] <= mid) {
			r = mid;
		}
		else {
			l = mid;
		}
	}
	cout << "! " << m1[r] + 1 << endl;
}