#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define sz(v) (int)v.size()
#define fastio ios_base::sync_with_stdio(false); cin.tie(NULL)

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

template<class T>
bool ckmin(T &a, const T &b) {
    if (b < a) {
        a = b;
        return true;
    }

    return false;
}

template<class T>
bool ckmax(T &a, const T &b) {
    if (b > a) {
        a = b;
        return true;
    }

    return false;
}

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const signed N = signed(1e7) + 100, MAXLOG = 20;

vector<int> lp(N, -1);

void process() {
    lp[0] = lp[1] = 1;

    for (int i = 2; i < N; ++i) {
        if (lp[i] == -1) {
            lp[i] = i;
            if (1ll * i * i >= N) continue;
            for (int j = i * i; j < N; j += i) {
                if (lp[j] == -1)
                    lp[j] = i;
            }
        }
    }
}

void solve() {
    int a, b; cin >> a >> b;
    set<int> exist;

    while (a > 1) {
        exist.insert(a);
        a /= lp[a];
    }

    exist.insert(1);

    while (b > 1) {
        if (exist.count(b)) {
            cout << b << "\n";
            return;
        }

        b /= lp[b];
    }

    cout << "1\n";
}

signed main() {
    fastio;

    process();

    int t; cin >> t;
    while (t--) solve();

    return 0;
}