#include <iostream>
#include <vector>

using namespace std;

int main() {
    long long n; cin >> n;
    for (int k = 0; k < n; k ++) {
        long long a, b; cin >> a >> b;
        if (a == 1) {
            cout << 1 << endl;
            continue;
        }
        if (b == 1) {
            cout << 1 << endl;
            continue;
        }
        vector<long long> pr_a(0);
        vector<long long> pr_b(0);
        long long i = 2;
        while (i <= a) {
            while (a % i != 0) {
                i += 1;
                if (i * i > a) {
                    i = a;
                }
            }
            a /= i;
            pr_a.push_back(i);
        }
        i = 2;
        while (i <= b) {
            while (b % i != 0) {
                i += 1;
                if (i * i > b) {
                    i = b;
                }
            }
            b /= i;
            pr_b.push_back(i);
        }
        long long in_a, in_b;
        in_a = pr_a.size();
        in_b = pr_b.size();
        long long ans = 1;
        while ((in_a >= 0) & (in_b >= 0) & (pr_a[in_a] == pr_b[in_b])) {
            ans *= pr_a[in_a];
            in_a -= 1;
            in_b -= 1;
        }
        cout << ans << endl;
    }
}