#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define all(x) (x).begin(), (x).end()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template <typename T>
inline int len(const T& x) {
    return x.size();
}

const int inf = 1e9 + 9;
const ll llinf = 1e18 + 9;
const ll MOD = 1e9 + 7;
const int maxN = 1e5 + 9;
struct seg {
    int l, r;
};
int dp[maxN];
unordered_set<int> is[maxN];
bool inter(seg a, seg b) {
    return max(a.l, b.l) <= min(a.r, b.r);
}
int n, m;

struct eve {
    int x, tp, lay, id;
    bool operator<(const eve& sec) const {
        if(x != sec.x) return x < sec.x;
        return tp < sec.tp;
    }
};

void init(vector<seg> ex, vector<seg> fr) {
    vector<eve> sl;
    for(int i = 0; i < len(ex); ++i) {
        sl.pb({ex[i].l, 1, 1, i});
        sl.pb({ex[i].r + 1, -1, 1, i});
    }
    for(int i = 0; i < len(fr); ++i) {
        sl.pb({fr[i].l, 1, 2, i});
        sl.pb({fr[i].r + 1, -1, 2, i});
    }

    sort(all(sl));
    unordered_set<int> cur1, cur2;
    for(auto &i: sl) {
        if(i.lay == 1) {
            if(i.tp == 1) {
                for(auto &j: cur2) {
                    is[j].insert(i.id);
                }
                cur1.insert(i.id);
            }
            else cur1.erase(i.id);
        }
        else {
            if(i.tp == 1) {
                for(auto &j: cur1) {
                    is[i.id].insert(j);
                }
                cur2.insert(i.id);
            }
            else cur2.erase(i.id);
        }
    }


}



int main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    cin >> n >> m;
    vector<seg> ex(2 * n);
    for(auto &i: ex) {
        cin >> i.l >> i.r;
    }

    vector<seg> fr(m);
    for(auto &i: fr) {
        cin >> i.l >> i.r;
    }

    init(ex, fr);

    for(int i = 0; i < m; ++i) {
        unordered_map<int, int> cnt;
        for(auto &j: is[i]) ++cnt[j / 2];
        bool bad = false;
        for(auto &j: cnt) if(j.second >= 2) bad = true;
        if(bad) {
            dp[i] = 0;
            continue;
        }

        vector<int> must;
        for(auto &j: cnt) {
            if(is[i].count(j.first * 2)) must.pb(j.first * 2 + 1);
            else must.pb(j.first * 2);
        }

        assert(len(must) <= 2);


        dp[i] = 1;

        for(int j = i - 1; j >= 0; --j) {
            bool ok = true;
            for(auto &k: must) {
                if(is[j].count(k)) {
                    ok = false;
                    break;
                }
            }
            if(ok) {
                dp[i] = max(dp[i], dp[j] + 1);
                break;
            }
        }

    }


    cout << *max_element(dp, dp + m) << '\n';

}
