#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define all(x) (x).begin(), (x).end()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template <typename T>
inline int len(const T& x) {
    return x.size();
}

const int inf = 1e9 + 9;
const ll llinf = 1e18 + 9;
const ll MOD = 1e9 + 7;
const int maxN = 1e5 + 9;
struct seg {
    int l, r;
};
int dp[maxN][2];
unordered_set<int> is[maxN];
bool inter(seg a, seg b) {
    return max(a.l, b.l) <= min(a.r, b.r);
}
int n, m;

struct eve {
    int x, tp, lay, id;
    bool operator<(const eve& sec) const {
        if(x != sec.x) return x < sec.x;
        if(tp != sec.tp) return tp < sec.tp;
        return lay < sec.lay;
    }
};

void init(vector<seg> ex, vector<seg> fr) {
    vector<eve> sl;
    for(int i = 0; i < len(ex); ++i) {
        sl.pb({ex[i].l, 1, 1, i});
        sl.pb({ex[i].r + 1, -1, 1, i});
    }
    for(int i = 0; i < len(fr); ++i) {
        sl.pb({fr[i].l, 1, 2, i});
        sl.pb({fr[i].r + 1, -1, 2, i});
    }

    sort(all(sl));
    unordered_set<int> cur1, cur2;
    for(auto &i: sl) {
        if(i.lay == 1) {
            if(i.tp == 1) {
                for(auto &j: cur2) {
                    is[j].insert(i.id);
                }
                cur1.insert(i.id);
            }
            else cur1.erase(i.id);
        }
        else {
            if(i.tp == 1) {
                for(auto &j: cur1) {
                    is[i.id].insert(j);
                }
                cur2.insert(i.id);
            }
            else cur2.erase(i.id);
        }
    }


}
bool bad[maxN];
int nxt[maxN];

vector<int> must[maxN];

int main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    cin >> n >> m;
    vector<seg> ex(2 * n);
    for(auto &i: ex) {
        cin >> i.l >> i.r;
    }

    vector<seg> fr(m);
    for(auto &i: fr) {
        cin >> i.l >> i.r;
        if(i.l != i.r) return 0;
    }

    init(ex, fr);
    int mx = 0;
    for(int i = 0; i < m; ++i) {
        unordered_map<int, int> cnt;
        for(auto &j: is[i]) ++cnt[j / 2];

        for(auto &j: cnt) if(j.second >= 2) bad[i] = true;

        dp[i][0] = mx;
        assert(!bad[i]);
        if(bad[i]) {
            dp[i][1] = -inf;
            nxt[i] = (i == 0 || !bad[i - 1] ? i - 1 : nxt[i - 1]);
            continue;
        }
        nxt[i] = (i == 0 || !bad[i - 1] ? i - 1 : nxt[i - 1]);


//        int must = inf;
        for(auto &j: cnt) {
//            if(is[i].count(j.first * 2)) must = min(must, j.first * 2 + 1);
//            else must = min(must, j.first * 2);
            if(is[i].count(j.first * 2)) must[i].pb(j.first * 2 + 1);
            else {
                assert(!is[i].count(j.first * 2));
                must[i].pb(j.first * 2);
            }
        }


        assert(len(cnt) <= 2);


        dp[i][1] = 1;

        {
//            int j = nxt[i];
            int j = i - 1;
            while(j >= 0) {
                bool ok = true;
                for(auto &k: must[i]) ok &= !is[j].count(k);
                for(auto &k: must[j]) ok &= !is[i].count(k);

                if(ok) {
                    dp[i][1] = max(dp[i][1], dp[j][1] + 1);
                    break;
                }
                --j;
//                j = nxt[j];
            }
        }


        mx = max(mx, dp[i][1]);
    }


    cout << max(dp[m - 1][0], dp[m - 1][1]) << '\n';

}
