#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define all(x) (x).begin(), (x).end()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template <typename T>
inline int len(const T& x) {
    return x.size();
}

const int inf = 1e9 + 9;
const ll llinf = 1e18 + 9;
const ll MOD = 1e9 + 7;
const int maxN = 1e7 + 9;
int sieve[maxN];
bool prime[maxN];
void init() {
    memset(prime, true, sizeof(prime));
    for(int i = 2; i < maxN; ++i) {
        if(prime[i]) {
            sieve[i] = i;
            for(ll j = ll(i) * ll(i); j < maxN; j += i) {
                sieve[j] = i;
                prime[j] = 0;
            }
        }
    }
}
vector<int> fact(int n) {
    vector<int> res;
    while(n > 1) {
        res.pb(sieve[n]);
        n /= res.back();
    }
    if(n > 1) res.pb(n);
    return res;
}
void solve() {
    int a, b; cin >> a >> b;
    auto fa = fact(a), fb = fact(b);
    int ans = 1;
    for(int i = 0; i < len(fa) && i < len(fb); ++i) {
        if(fa[len(fa) - 1 - i] != fb[len(fb) - 1 - i]) break;
        ans *= fa[len(fa) - 1 - i];
    }
    cout << ans << '\n';
}
int main() {

    cin.tie(); cout.tie(0); ios_base::sync_with_stdio(0);
    init();
    int tc; cin >> tc;
    while(tc--) solve();
}
