//#pragma GCC optimize("O3,no-stack-protector,unroll-loops,fast-math")
//#pragma GCC target("avx,avx2,fma,sse,sse2,sse3,sse4")
//#pragma comment(linker,"/STACK:4294967296")
#include<bits/stdc++.h>
using namespace std;
#define ff first
#define ss second
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define log(x) __lg(x)
#define gcd(a, b) __gcd(a, b)
typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<vpii> vvpii;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vpll> vvpll;
typedef vector<bool> vb;
const ll mod = 1e9+7;


#define debug 0

struct segm{
    int l, r;
    vi cost;
    int id = -1;

    segm(){};

    segm(int _l, int _r){
        l = _l;
        r = _r;
    }
};

int findl(const vector<segm> &a, int lq){
    int l = -1;
    int r = a.size()-1;

    while(l+1 < r){
        int m = l + (r-l)/2;

        if(a[m].r < lq){
            l = m;
        }
        else{
            r = m;
        }
    }

    return r;
}


int findr(const vector<segm> &a, int rq){
    int l = 0;
    int r = a.size();

    while(l+1 < r){
        int m = l + (r-l)/2;

        if(a[m].l < rq){
            l = m;
        }
        else{
            r = m;
        }
    }

    return l;
}

int main(){
    if(!debug) ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector<segm> a(2*n);

    for(int i=0; i<2*n; i++){
        cin >> a[i].l >> a[i].r;
        a[i].id = i/2;
    }

    for(int i=0; i<m; i++){
        int l, r;
        cin >> l >> r;

        int itl = findl(a, l);
        int itr = findr(a, r);

        for(int j=itl; j<=itr; j++){
            a[i].cost.push_back(i);
        }

    }

    int ans = m;
    set<int> used;

    for(int i=0; i<2*n; i+=2){
        vi l, r;

        for(int j: a[i].cost){
            if(used.find(j) == used.end()){
                l.push_back(j);
            }
        }

        for(int j: a[i+1].cost){
            if(used.find(j) == used.end()){
                r.push_back(j);
            }
        }

        if(l.size() <= r.size()){
            ans -= l.size();
            for(int j: l){
                used.insert(j);
            }
        }
        else{
            ans -= r.size();
            for(int j: r){
                used.insert(j);
            }
        }
    }

    cout << ans << '\n';

    return 0;
}
