//#pragma GCC optimize("O3,no-stack-protector,unroll-loops,fast-math")
//#pragma GCC target("avx,avx2,fma,sse,sse2,sse3,sse4")
//#pragma comment(linker,"/STACK:4294967296")
#include<bits/stdc++.h>
using namespace std;
#define ff first
#define ss second
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define log(x) __lg(x)
#define gcd(a, b) __gcd(a, b)
typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<vpii> vvpii;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vpll> vvpll;
typedef vector<bool> vb;
const ll mod = 1e9+7;


#define debug 0

struct segm{
    int l, r;
    int id = -1;

    segm(){};

    segm(int _l, int _r){
        l = _l;
        r = _r;
    }
};

bool intersect(segm a, segm b){
    return (a.l <= b.l && b.l <= a.r) || (b.l <= a.l && a.l <= b.r);
}



int main(){
    if(!debug) ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector<segm> a(2*n);
    vector<segm> b(m);

    for(int i=0; i<2*n; i++){
        cin >> a[i].l >> a[i].r;
        a[i].id = i/2;
    }

    for(int i=0; i<m; i++){
        cin >> b[i].l >> b[i].r;
    }

    int ans = 0;

    for(int mask=0; mask<(1<<m); mask++){
        vi used(2*n, 0);
        int k = 0;
        for(int j=0; j<m; j++){
            if((mask>>j) & 1){
                k++;
                for(int i=0; i<2*n; i++){
                    if(intersect(b[j], a[i])){
                        used[i] = 1;
                    }
                }
            }
        }
        bool norm = true;
        for(int i=0; i<n; i++){
            norm &= ((used[i]+used[2*i]) <= 1);
        }

        if(norm){
            ans = max(ans, k);
        }
    }


    cout << ans << '\n';

    return 0;
}
