//#pragma GCC optimize("O3,no-stack-protector,unroll-loops,fast-math")
//#pragma GCC target("avx,avx2,fma,sse,sse2,sse3,sse4")
//#pragma comment(linker,"/STACK:4294967296")
#include<bits/stdc++.h>
using namespace std;
#define ff first
#define ss second
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define log(x) __lg(x)
#define gcd(a, b) __gcd(a, b)
typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<vpii> vvpii;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vpll> vvpll;
typedef vector<bool> vb;
const int inf = 1e9+7;


#define debug 0

vi esv;

void init(){
    esv.resize(int(1e7), inf);

    esv[0] = 0;
    esv[1] = 0;

    for(int i=2; i<esv.size(); i++){
        if(esv[i] != inf){
            continue;
        }
        esv[i] = i;
        for(int j=i*i; j<esv.size(); j += i){
            esv[j] = min(i, esv[j]);
        }
    }
}


vpii fact(int x){
    unordered_map<int, int> pre_ans;

    while(x > 1){
        pre_ans[esv[x]]++;
        x /= esv[x];
    }

    vpii ans;
    for(auto i: pre_ans){
        ans.push_back(i);
    }

    return ans;
}


int main(){
    if(!debug) ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int q;
    cin >> q;
    init();

    while(q--){
        int a, b;
        cin >> a >> b;

        vpii af = fact(a);
        vpii bf = fact(b);

        sort(rall(af));
        sort(rall(bf));

        int ans = 1;

        for(int i=0; i<min(af.size(), bf.size()); i++){
            if(af[i].ff == bf[i].ff){
                int alpha = min(af[i].ss, bf[i].ss);
                while(alpha > 0){
                    ans *= af[i].ff;
                    alpha--;
                }

                if(max(af[i].ss, bf[i].ss) > 0){
                    break;
                }
            }
            else{
                break;
            }
        }

        cout << ans << '\n';
    }

    return 0;
}
