#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using namespace std;
#define ll long long
#define ull unsigned long long
#define fir first
#define sec second
#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front
#define SORT(v) sort(v.begin(), v.end())
#define REVERSE(v) reverse(v.begin(), v.end())

typedef tree<int, null_type, less<int>,
        rb_tree_tag, tree_order_statistics_node_update> indexed_set;

int n, V = 1, P = -1;
vector <vector <int>> g;
vector <bool> used;
vector <int> lvl;
vector <int> pr;

void dfs(int v, int p){
    pr[v] = p;
    used[v] = 1;
    for (auto i : g[v]){
        if (!used[i]){
            lvl[i] = lvl[v] + 1;
            dfs(i, v);
        }
    }
}

void solve(){
    cin >> n;
    g.resize(n+1);
    used.resize(n+1);
    lvl.resize(n+1);
    pr.resize(n+1);
    for (int i=0; i<n-1; i++){
        int x, y;
        cin >> x >> y;
        g[x].pb(y);
        g[y].pb(x);
    }
    while (1){
        used.assign(n+1, 0);
        lvl.assign(n+1, 0);
        if (P != -1)
            used[P] = 1;
        lvl[V] = 1;
        dfs(V, -1);
        int mx_lvl = -1, mx;
        for (int i=1; i<=n; i++){
            if (lvl[i] > mx_lvl){
                mx_lvl = lvl[i];
                mx = i;
            }
        }
        used.assign(n+1, 0);
        lvl.assign(n+1, 0);
        lvl[V] = 1;
        if (P != -1)
            used[P] = 1;
        dfs(mx, -1);
        mx_lvl = -1;
        for (int i=1; i<=n; i++){
            if (lvl[i] > mx_lvl){
                mx_lvl = lvl[i];
                mx = i;
            }
        }
        used.assign(n+1, 0);
        vector <int> v;
        while (1){
            v.pb(mx);
            used[mx] = 1;
            if (pr[mx] == -1)
                break;
            mx = pr[mx];
        }
        int l = 0, r = v.size();
        while (1){
            int m = l + (r-l)/2;
            cout << v[m] << endl;
            int res;
            cin >> res;
            if (res == 0){
                cout << "! " << v[m];
                return;
            }
            else if (m == l || !used[res]){
                V = res;
                P = v[m];
                break;
            }
            else if (m == v.size() - 1 || res != v[m+1])
                r = m;
            else
                l = m;
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0),cout.tie(0);

    int t = 1;
    while (t--){
        solve();
    }
}
