#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <cmath>
#include <cstdlib>

using namespace std;
#define int long long
#pragma GCC optimize("O3")

int n;
vector<pair<int, int>> rng;

bool intrs(pair<int, int> v1, pair<int, int> v2) {
    if (v1.second < v2.first) return false;
    if (v2.second < v1.first) return false;
    return true;
}

int bin1(int x) {
    int l = 0;
    int r = rng.size() - 1;
    // it.second >= x
    if (rng[l].second >= x) return l;
    if (rng[r].second < x) return r + 1;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (rng[mid].second < x) {
            l = mid;
        }
        else {
            r = mid;
        }
    }
    return r;
}

int bin2(int x) {
    int l = 0;
    int r = rng.size() - 1;
    // it.first <= x
    if (rng[l].first > x) return -1;
    if (rng[r].first <= x) return r;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (rng[mid].first <= x) {
            l = mid;
        }
        else {
            r = mid;
        }
    }
    return l;
}

int binfrst(pair<int, int> v) {
    int l = bin1(v.first);
    int r = bin2(v.second);
    for (int i = l; i <= r; i++) {
        if (intrs(rng[i], v)) return i;
    }
    return -1;
}

int binlst(pair<int, int> v) {
    int l = bin1(v.first);
    int r = bin2(v.second);
    for (int i = r; i >= l; i--) {
        if (intrs(rng[i], v)) return i;
    }
    return -1;
}

signed main() {
    int m;
    cin >> n >> m;
    rng.resize(n * 2);
    for (int i = 0; i < n; i++) {
        cin >> rng[i * 2].first >> rng[i * 2].second;
        cin >> rng[i * 2 + 1].first >> rng[i * 2 + 1].second;
    }
    vector<vector<int>> dp(n, vector<int>(2));
    vector<int> prevp(n * 2);
    vector<int> cpick(n * 2);
    int dob = 0;
    for (int qq = 0; qq < m; qq++) {
        int a, b;
        cin >> a >> b;
        int p1 = binfrst({ a, b });
        int p2 = binlst({ a, b });
        if (p1 == -1) {
            dob++;
            continue;
        }
        if (p2 - p1 > 1) continue;
        if (p1 == p2) {
            cpick[p1]++;
        }
        else if (p2 % 2 == 0) {
            prevp[p2]++;
        }
    }
    for (int i = 0; i < n; i++) {
        dp[i][0] = cpick[i * 2];
        dp[i][1] = cpick[i * 2 + 1];
        if (i) {
            dp[i][0] += max(dp[i - 1][0], dp[i - 1][1]);
            dp[i][1] += max(dp[i - 1][0], dp[i - 1][1]);
        }
        if (i) {
            int nv = cpick[i * 2] + prevp[i * 2] + dp[i - 1][1];
            dp[i][0] = max(dp[i][0], nv);
        }
    }
    cout << max(dp[n - 1][0], dp[n - 1][1]) + dob;  
    return 0;
}
