#include <iostream>
#include <vector>

using namespace std;

int n, u, v;
vector<vector<int>> g;
bool blocked[200010];

pair<int, int> getfurth(int x, int d, int p){
    pair<int, int> ans = {x, d}, k;
    for (int i : g[x]) {
        if (!blocked[i] && i != p) {
            k = getfurth(i, d + 1, x);
            if (k.second > ans.second) {
                ans = k;
            }
        }
    }
    return ans;
}

int aa;

pair<int, int> getmid(int x, int d, int p) {
    pair<int, int> ans = {x, d}, k;
    for (int i : g[x]) {
        if (!blocked[i] && i != p) {
            k = getmid(i, d + 1, x);
            //cout << k.first << ' ' << k.second << ' ' << d << endl;
            if (k.second > ans.second) {
                if (d == (k.second >> 1)) {
                    aa = x;
                }
                ans = k;
            }
        }
    }
    return ans;
}

inline int getdcentre(int beg) {
    int fp = getfurth(beg, 0, -1).first;
    aa = fp;
    //cout << fp << endl;
    getmid(fp, 0, -1);
    return aa;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    g.resize(n);
    for (int i = 1; i < n; ++i) {
        cin >> u >> v; --u; --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int pintree = 0, nex;
    while (1) {
        int fi = getdcentre(pintree);
        cout << fi + 1 << endl;
        cin >> nex; --nex;
        if (nex == -1) {
            cout << "! " << fi+1 << endl;
            break;
        }
        blocked[fi] = true;
        pintree = nex;
    }
}
