#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

int main(){
    int n, a, b;
    vector<int> facta, factb;
    cin >> n;
    for(int i = 0; i < n; ++i){
        cin >> a >> b;
        facta.clear();
        factb.clear();
        for(int i = 2; i < sqrt(a)+2; ++i){
            while (a % i == 0){
                facta.push_back(i);
                a /= i;
            }
        }
        if(a != 1){
            facta.push_back(a);
        }
        for(int i = 2; i < sqrt(b)+2; ++i){
            while (b % i == 0){
                factb.push_back(i);
                b /= i;
            }
        }
        if(b != 1){
            factb.push_back(b);
        }
        int ymod = -1;
        int ans = 1;
        while(min(facta.size(), factb.size()) >= -ymod && facta[facta.size()+ymod] == factb[factb.size()+ymod]){
            --ymod;
            ans *= facta[facta.size()+ymod];
        }
        cout << ans << '\n';
    }
}
