#include<bits/stdc++.h>
#include <random>
#include <ctime>
#define dbg(x) cerr << #x << "=" << x << "\n";
using namespace std;

mt19937 rnd(199);

struct node{
    long long l;
    long long r;
};

long long foo(long long l1, vector<long long> &b, vector<node> &f){
    long long in = lower_bound(b.begin(), b.end(), l1) -  b.begin();

    in--;

    if(in == -1 ||  (in < b.size() &&  f[in].r < l1)){
        in++;
    }

    return in;
}

long long bar(long long r, vector<long long> &b, vector<node> &f){
    long long in = lower_bound(b.begin(), b.end(), r) -  b.begin();

    if(in == b.size() || (in >= 0 && f[in].l > r)){
        in--;
    }

    return in;
}

void solve(){
    long long n, m; cin >> n >> m;

    vector<node> f;
    vector<node> s;

    vector<long long> s_l_f;
    vector<long long> b;

    for(int i=0; i < n; i++){
        long long fl, fr, sl, sr; cin >> fl >> fr >> sl >> sr;

        f.push_back({fl, fr});
        s.push_back({sl, sr});

        s_l_f.push_back(fl);
        b.push_back(sr);
    }

    long long ans=0;

    vector<pair<long long, long long>> a(n, {0, 0});

    for(int i=0; i < m; i++){
        long long l, r; cin >> l >> r;
        long long f_in = foo(l, s_l_f, f);
        long long s_in = bar(r, b, s);

        if(s_in - f_in < 1){
            bool have=false;

            if(f_in < n && f_in >= 0){
                if(!(f[f_in].l > r || f[f_in].r < l)){
                    a[f_in].second++;
                    have=true;
                }
            }

            if(s_in < n && s_in >= 0){
                if(!(s[s_in].l > r || s[s_in].r < l)){
                    a[s_in].first++;
                    have=true;
                }
            }

            if(!have){
                ans++;
            }
        }
    }

    for(auto el: a){
        ans += max(el.first, el.second);
    }

    cout << ans;
}

int main(){
    /*ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);*/

   long long t=1;

  // cin >> t;

    for(int i=0; i < t; i++){
        solve();

        cout << "\n";
    }
}

/*

    long long n, m; cin >> n >> m;

    vector<node> f;
    vector<node> s;

    vector<long long> s_l_f;
    vector<long long> b;

    for(int i=0; i < n; i++){
        long long fl, fr, sl, sr; cin >> fl >> fr >> sl >> sr;

        f.push_back({fl, fr});
        s.push_back({sl, sr});

        s_l_f.push_back(fl);
        b.push_back(sr);
    }

    long long ans=0;

    for(int i=0; i < m; i++){
        long long l, r; cin >> l >> r;
        long long f_in = foo(l, s_l_f, f);
        long long s_in = bar(r, b, s);

        dbg(f_in);
        dbg(s_in);

        if(s_in - f_in < 1){
            ans++;
        }
    }

    cout << ans;
    */

