#include<bits/stdc++.h>
#include <random>
#include <ctime>
#define dbg(x) cerr << #x << "=" << x << "\n";
using namespace std;

mt19937 rnd(199);

void dfs(long long v){
    cout << v+1 << "\n";

    long long c; cin >> c; c--;

    if(c==-1){
        cout << "! " << v+1 << "\n";

        exit(0);
    }

    dfs(c);
}

void dfs(long long v, long long p, vector<vector<long long>> &g, vector<long long> &a){
    a.push_back(v);

    for(auto el: g[v]){
        if(el != p){
            dfs(el, v, g, a);
        }
    }
}

void solve1(long long n, vector<vector<long long>> &g){
    long long s=0;

    for(int i=0; i < n; i++){
        if(g[i].size()==1){
            s=i;
        }
    }

    vector<long long> a;

    dfs(s, -1, g, a);

    // бин поиск

    long long l=0;
    long long r=n;

    while(r-l > 1){
        long long m =(l+r)/2;

        cout << a[m]+1 << "\n";

        long long c; cin >> c;

        if(c==0){
            l=m;

            break;
        }
        c--;

        if(a[m-1] == c){
            r=m;
        }else{
            l=m;
        }
    }

    cout << "! " << a[l]+1;
}

void solve(){
    long long n; cin >> n;

    vector<vector<long long>> g(n, vector<long long> ());

    for(int i=0; i < n-1; i++){
        long long u, v; cin >> u >> v; u--;v--;

        g[u].push_back(v);
        g[v].push_back(u);
    }

    if(n <= 20){
        dfs(0);

        return;
    }

    solve1(n, g);

}

int main(){
    /*ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);*/

   long long t=1;

  // cin >> t;

    for(int i=0; i < t; i++){
        solve();

        cout << "\n";
    }
}

