#include <iostream>
#include <vector>
#include <set>
#include <map>

int n;
std::vector<std::vector<int>> graph;
std::vector<int> sz, used, vis;

void sizes(int ver, int p = -1) {
    sz[ver] = 1;
    vis.push_back(ver);
    for (auto to : graph[ver]) {
        if (to == p || used[to]) {
            continue;
        }
        sizes(to, ver);
        sz[ver] += sz[to];
    }
}


signed main() {


    std::cin >> n;
    graph.resize(n);
    sz.resize(n);
    used.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        std::cin >> v >> u;
        --v, --u;
        graph[v].push_back(u);
        graph[u].push_back(v);
    }
    //sizes(0);
    int start = 0;
    while (true) {
        sizes(start);
        int want_ask = start;
        for (auto elem : vis) {
            bool centr = true;
            int sum = 0;
            for (auto to : graph[elem]) {
                if (sz[to] > sz[elem] || used[to]) {
                    continue;
                }
                if (sz[to] * 2 > sz[start]) {
                    centr = false;
                }
                sum += sz[to];
            }
            if (sum * 2 < sz[start]) {
                centr = false;
            }
            if (centr) {
                want_ask = elem;
                break;
            }
        }
        std::cout << want_ask + 1 << std::endl;
        int res;
        std::cin >> res;
        if (res == 0) {
            std::cout << "! " << want_ask + 1 << std::endl;
            return 0;
        }
        --res;
        for (auto to : graph[want_ask]) {
            if (to != res) {
                used[to] = true;
            }
        }
        start = res;


    }
    

    return 0;
}