#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

std::vector<int> fact(int n) {
    int pt = 2;
    std::vector<int> ans;
    while (pt * pt <= n) {
        while (n % pt == 0) {
            ans.push_back(pt);
            n /= pt;
        }
        ++pt;
    }
    if (n != 1) {
        ans.push_back(n);
    }
    return ans;
}

signed main() {

    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    int n;
    std::cin >> n;
    std::vector<int> a_fact, b_fact;
    for (int i = 0; i < n; ++i) {
        long long a, b;
        std::cin >> a >> b;
        if (a == b) {
            std::cout << a << '\n';
            continue;
        }
        a_fact.clear();
        b_fact.clear();
        a_fact = fact(a);
        b_fact = fact(b);
        //std::vector<int> a_fact = fact(a);
        //std::vector<int> b_fact = fact(b);
        /*for (auto elem : a_fact) {
            std::cout << elem << " ";
        }
        std::cout << std::endl;
        for (auto elem : b_fact) {
            std::cout << elem << " ";
        }
        std::cout << std::endl;*/
        if (a == 1 || b == 1) {
            std::cout << 1 << '\n';
            continue;
        }
        int pta = (a_fact.size()) - 1;
        int ptb = (b_fact.size()) - 1;
        while (pta >= 0 && ptb >= 0 && a_fact[pta] == b_fact[ptb]) {
            --pta, --ptb;
        }
        int ans = 1;
        for (int i = ptb + 1; i < b_fact.size(); ++i) {
            ans *= b_fact[i];
        }
        std::cout << ans << '\n';

    }

    return 0;
}