#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

signed main() {

    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);

    int n, m;
    std::cin >> n >> m;
    std::vector<long long> d(m + 1);
    int q;
    std::cin >> q;
    while (q--) {
        int left, right;
        std::cin >> left >> right;
        --left, --right;
        int t1 = left / m;
        int t2 = right / m;
        if (t1 == t2) {
            ++d[left % m];
            --d[right % m + 1];
        } else {
            int cnt = t2 - t1 - 1;
            d[0] += cnt;
            d[m] -= cnt;
            d[0] += 1;
            d[(right) % m + 1] -= 1;
            d[(left) % m] += 1;
            d[m] -= 1;
        }
    }
    std::vector<int> a(m);
    a[0] = d[0];
    for (int i = 1; i < m; ++i) {
        a[i] = a[i - 1] + d[i];
    }
    int min = 1e9;
    for (int i = 0; i < m; ++i) {
        if (a[i] < min) {
            min = a[i];
        }
    }
    std::cout << min;
    return 0;
}