#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

#define int long long

signed main() {

    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);

    int n, m;
    std::cin >> n >> m;
    int q;
    std::cin >> q;
    std::vector<std::pair<long long, long long>> queries;
    int on_all = 0;
    std::vector<long long> all;
    for (int i = 0; i < q; ++i) {
        int left, right;
        std::cin >> left >> right;
        --left, --right;
        int t1 = left / m;
        int t2 = right / m;
        if (t1 == t2) {
            all.push_back(left % m);
            all.push_back((right % m) + 1);
            queries.push_back({left % m, (right % m) + 1});
            //++d[left % m];
            //--d[right % m + 1];
        } else {
            int cnt = t2 - t1 - 1;
            on_all += cnt;
            //d[0] += cnt;
            //d[m] -= cnt;
            queries.push_back({0, (right % m) + 1});
            queries.push_back({left % m, m});
            all.push_back(0);
            all.push_back(m);
            all.push_back((right % m) + 1);
            all.push_back(left % m);
            //d[0] += 1;
            //d[(right) % m + 1] -= 1;
            //d[(left) % m] += 1;
            //d[m] -= 1;
        }
    }
    std::sort(all.begin(), all.end());
    all.erase(std::unique(all.begin(), all.end()), all.end());
    /*for (auto elem : all) {
        std::cout << elem << " ";
    }
    std::cout << std::endl;*/
    std::map<long long, long long> inv;
    for (int i = 0; i < all.size(); ++i) {
        inv[all[i]] = i;
    }
    std::vector<long long> d(all.size() + 1);
    for (int i = 0; i < queries.size(); ++i) {
        int left = inv[queries[i].first];
        int right = inv[queries[i].second];
        //++right;
        ++d[left];
        --d[right];
    }
    d[inv[0]] += on_all;
    d[inv[m]] -= on_all;
    std::vector<int> a(all.size());
    /*for (auto elem : d) {
        std::cout << elem << " ";
    }
    std::cout << std::endl;*/
    a[0] = d[0];
    for (int i = 1; i < all.size(); ++i) {
        a[i] = a[i - 1] + d[i];
    }
    int min = 2e18;
    for (int i = 0; i < all.size() - 1; ++i) {
        if (a[i] < min) {
            min = a[i];
        }
    }
    std::cout << min;
    return 0;
}
