#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <map>
#include <bitset>

using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m; cin >> n >> m;
    vector<pair<int, int>> f(n), s(n);
    vector<pair<int, int>> ot(m);
    for (int i = 0; i < n; i++) {
        cin >> f[i].first >> f[i].second;
        cin >> s[i].first >> s[i].second;
    }
    for (int i = 0; i < m; i++)
        cin >> ot[i].first >> ot[i].second;
    if (m <= 10) {
        int ans = 0;
        for (int i = 0; i < (1 << m); i++) {
            bitset<10> t = i;
            bool flag = 1;
            int ans1 = 0;
            for (int j = 0; j < n; j++) {
                bool flag1 = 1, flag2 = 1;
                for (int k = 0; k < m; k++) {
                    if (t[k] == 0)
                        continue;
                    if (max(ot[k].first, f[j].first) <= min(ot[k].second, f[j].second)) {
                        flag1 = 0;
                    }
                    if (max(ot[k].first, s[j].first) <= min(ot[k].second, s[j].second))
                        flag2 = 0;
                }
                flag = flag && (flag1 || flag2);
            }
            if (flag) {
                for (int j = 0; j < m; j++)
                    ans1 += t[j];
            }
            ans = max(ans, ans1);
        }
        cout << ans;
        return 0;
    }
    int ans = m;
    int l = 0, cnt1, cnt2;
    for (int i = 0; i < n; i++) {
        cnt1 = 0, cnt2 = 0;
        while (l < m && ot[l].first < f[i].first)
            l++;
        while (l < m && ot[l].first <= f[i].second) {
            l++;
            cnt1++;
        }
        while (l < m && ot[l].first < s[i].first)
            l++;
        while (l < m && ot[l].first <= s[i].second) {
            l++;
            cnt2++;
        }
        ans -= min(cnt1, cnt2);
    }
    cout << ans;
    return 0;
}