#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <time.h>
#include <random>
#include <chrono>
#include <stdio.h>
#include <cstdio>
#include <map>
#include <algorithm>
#include <deque>
#include <numeric>
#include <memory>

using namespace std;
#define len(v) (int)(v).size()
#define ll long long
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define make_pair(u, v) mp(i,v)
#define int long long
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

inline void read(vector<int> &a) {
    for (auto &i : a)cin >> i;
}

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

int binpow(int a, int n) {
    if (n == 0)return 1;
    if (n & 1) {
        return a * binpow(a, n - 1);
    } else {
        int b = binpow(a, n / 2);
        return b * b;
    }
}

vector<vector<int>> g;
vector<int> up;
vector<int> down;
vector<int> used;

void dfs(int u, int pr = -1) {
    used[u] = 1;
    up[u] = pr;
    for (auto &to : g[u]) {
        if (!used[to]) {
            down[to] = u;
            dfs(to, u);
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //freopen("input.txt","r",stdin);
    //freopen("output.txt","w",stdout);
    int n, m, q;
    cin >> n >> m >> q;
    vector<int> add(m+1);
    int cnt = 0;
    while (q--) {
        int l, r;
        cin >> l >> r;
        int l_mod = (l - 1) % m;
        int r_mod = (r - 1) % m;
        //[l_mod.. m-1 + 0....m-1 + 0 + 1 + ... r_mod]
        int l_next = l + (m-1-l_mod)+1;
        if (r <= l_next){
            add[l_mod]++;
            if (r_mod == 0 && r - l>= m){
                add[m]--;
                add[0]++;
                add[1]--;
            }
            else{
                add[r_mod+1]--;
            }
            continue;
        }
        else{
            add[l_mod]++;
            add[m]--;
        }
        int r_pref = r - r_mod - 1;
        add[0]++;
        add[r_mod+1]--;

        cnt += (r_pref-l_next+1)/m;


    }
    for (int i = 1;i <= m;++i){
        add[i] += add[i-1];
    }
    add.pop_back();
    cout << cnt + *min_element(all(add));
    return 0;
}
