#include <iostream>
#include <vector>
#include <utility>

using namespace std;

vector<int> p;

void precalc() {
    for (int i = 2; i * i <= 10000010; ++i) {
        bool ok = true;
        for (auto j: p) {
            if (i % j == 0)
                ok = false;
        }
        if (ok)
            p.push_back(i);
    }
}

int gcd(int a, int b) {
    if (b == 0)
        return a;
    return gcd(b, a % b);
}


vector<pair<int, int>> calc_del(int a) {
    vector<pair<int, int>> ans;
    for (int i: p) {
        int am = 0;
        while (a % i == 0) {
            am += 1;
            a /= i;
        }
        ans.push_back({i, am});
    }
    if (a != 0) {
        ans.push_back({a, 1});
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    precalc();
    int n;
    cin >> n;
    while(n--) {
        int a, b;
        cin >> a >> b;
        if (a > b)
            swap(a, b);
        int c = gcd(a, b);
        auto d = calc_del(a);
        int min_up = 0;
        int fa = -1;
        for (auto i: d) {
            if (c % a == 0) {
                fa = a;
                break;
            }
            for (int j = 0; j < i.second; ++j) {
                a /= i.first;
                if (c % a == 0) {
                    fa = a;
                    break;
                }
            }
            if (fa != -1)
                break;
        }
        auto e = calc_del(b / fa);
        int nfa = fa;
        bool o = true;
        for (auto i: e) {
            for (int j = 0; j < i.second; ++j) {
                if (nfa < i.first) {
                    o = false;
                    break;
                }
                nfa *= i.first;
            }
        }
        if (o)
            cout << fa << "\n";
        else
            cout << 1 << "\n";
    }
}


