#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>

using namespace std;

vector<int> p;

void precalc() {
    for (int i = 2; i * i <= 10000010; ++i) {
        bool ok = true;
        for (auto j: p) {
            if (i % j == 0)
                ok = false;
        }
        if (ok)
            p.push_back(i);
    }
}

vector<pair<int, int>> calc_del(int a) {
    vector<pair<int, int>> ans;
    for (int i: p) {
        int am = 0;
        while (a % i == 0) {
            am += 1;
            a /= i;
        }
        ans.push_back({i, am});
    }
    if (a != 0) {
        ans.push_back({a, 1});
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    precalc();
    int n;
    cin >> n;
    while(n--) {
        int a, b;
        cin >> a >> b;
        if (a > b)
            swap(a, b);
        auto c = calc_del(a);
        auto d = calc_del(b);
        int di = 0;
        for (int i = 1; i < =min(d.size(), c.size()); ++i) {
            if (d[d.size() - i].first == c[c.size() - i].first && d[d.size() - i].second == c[c.size() - i].second)
                di += 1;
            else if (d[d.size() - i].first == c[c.size() - i].first) {
                di += 1;
                break;
            } else {
                break;
            }
        }
        int ans = 1;
        for (int i = 0; i < di; ++i) {
            for (int j = 0; j < min(c[i].second, d[i].second); ++j) {
                ans *= c[i].first;
            }
        }
        cout << ans << "\n";
    }
}


