#include <iostream>
#include <vector>
#include <string>
#include <cassert>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#define int long long
using namespace std;
vector <vector <int> > g; 
vector <int> usd;
vector <int> sz;
void cnt_sz(int v,int p) {
    sz[v] = 1;
    
    for (auto u : g[v]) {
        if (!usd[u] && u != p) {
            cnt_sz(u, v);
            sz[v] += sz[u];
        }
    }
}
int find_c(int v, int p, int szz) {
    for (auto u : g[v]) {
        if (!usd[u] && u!=p && sz[u] > szz / 2) {
            return find_c(u, v, szz);
        }
    }
    return v;
}
void solve(int v) {
    cnt_sz(v, -1);
    int c = find_c(v, -1, sz[v]);
    cout << c + 1 << endl;
    int an;
    cin >> an;
    if (an == 0) {
        cout << "! " << c + 1 << endl;
        return;
    }
    an--;
    usd[c] = 1;
    solve(an);

}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    g.resize(n);
    usd.resize(n);
    sz.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    solve(0);


}