#include <iostream>
#include <vector>
#include <string>
#include <cassert>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#define int long long
using namespace std;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int q;
    cin >> q;
    vector <int> md(1e7 + 1);
    for (int i = 2; i <= 1e7; ++i) {
        if (!md[i]) {
            md[i] = i;
            for (int j = i * i; j <= 1e7; j += i) {
                md[j] = i;
            }
        }
    }
    for (int t = 0; t < q; ++t) {
        int a, b;
        cin >> a >> b;
        int st1 = 1;
        int st2 = 1;
        int e = md[a];
        int u = md[b];
        unordered_map <int, int> rz1;
        set <int> d;
        while (a > 1) {
            rz1[md[a]]++;
            d.insert(md[a]);
            a /= md[a];
        }
        unordered_map <int, int> rz2;
        while (b > 1) {
            rz2[md[b]]++;
            d.insert(md[b]);
            b /= md[b];
        }
        auto it = d.end();
        it--;
        int ans = 1;
        while (true) {
            int p = (*it);
            if (rz1[p] == rz2[p]) {
                for (int i = 0; i < rz1[p]; ++i) {
                    ans *= p;
                }
            }
            else {
                for (int i = 0; i < min(rz1[p], rz2[p]); ++i) {
                    ans *= p;
                }
                break;
            }
            if (it == d.begin()) {
                break;
            }
            it--; 
        }
        cout << ans<<"\n";
    }

}