#include <iostream>
#include <vector>
#include <string>
#include <cassert>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#include <algorithm>
#define int long long
using namespace std;
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int h, w;
    cin >> w >> h;

    int n, m;
    cin >> n >> m;
    if (n == 1 && m == 1) {
        int x1, y1, a1;
        int x2, y2, a2;
        cin >> x1 >> y1 >> a1 >> x2 >> y2 >> a2;
        cout << min(a1, a2) << " " << abs(x2 - x1) + abs(y2 - y1) << "\n";
        return 0;
    }
    if (h == 1) {
        vector <vector <int> > homes;
        vector <vector <int> > ferms;

        int ans = 0, sma = 0, smb = 0;
        for (int i = 0; i < n; ++i) {
            int x, y, a;
            cin >> x >> y >> a;
            sma += a;
            homes.push_back({ x,a });
        }
        for (int i = 0; i < m; ++i) {
            int x, y, b;
            cin >> x >> y >> b;
            smb += b;
            ferms.push_back({ x,b });
        }
        ans = min(sma, smb);
        sort(homes.begin(), homes.end());
        sort(ferms.begin(), ferms.end());
        int l = 0;
        int r = 1e6;
        while (r - l > 1) {
            int mid = (r + l) / 2;
            int mxc = 0;
            int uk1 = homes.size() - 1;
            int uk2 = ferms.size() - 1;
            vector <vector <int> > h1 = homes;
            vector <vector <int> > f1 = ferms;
            while (uk1 >= 0 && uk2 >= 0) {
                if (abs(f1[uk2][0] - h1[uk1][0]) <= mid) {
                    int mn = min(f1[uk2][1], h1[uk1][1]);
                    mxc += mn;
                    f1[uk2][1] -= mn;
                    h1[uk1][1] -= mn;
                    if (h1[uk1][1] == 0) {
                        uk1--;
                    }
                    if (f1[uk2][1]==0){
               
                        uk2--;
                    }
                    
                }
                else {
                    uk1--;
                }
            }
            if (mxc == ans) {
                r = mid;
            }
            else {
                l = mid;
            }
        }
        cout << ans << " " << r;
    }
}
/*
10 1
4 4
4 1 1
5 1 1
6 1 1
9 1 1
1 1 1
3 1 1
7 1 1
10 1 1
*/