#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("tune=native")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll N = 2e5, INF = 1e18;

vector<ll> G[N];
set<ll> alive;
ll W[N];
ll S[N];
ll D[N];

ll query(ll v) {
    cout << v + 1 << endl;
    ll u;
    cin >> u;
    u--;
    return u;
}

void dfs(ll v, ll w = -1) {
    S[v] = 1;
    D[v] = 0;
    for (ll u : G[v]) {
        if (w == u || W[u]) continue;
        dfs(u, v);
        D[v] = max(D[v], S[u]);
        S[v] += S[u];
    }
    D[v] = max(D[v], ll(alive.size()) - S[v]);
}

void g_mark(ll v, ll w = -1) {
    alive.erase(v);
    W[v] = 1;
    for (ll u : G[v]) if (u != w && !W[u]) g_mark(u, v);
}

int main() {
#ifndef AVEVAD
    //cin.tie(0);
    //ios_base::sync_with_stdio(0);
#endif
    ll n;
    cin >> n;
    for (ll i = 0; i < n - 1; i++) {
        ll v, u;
        cin >> v >> u;
        v--, u--;
        G[v].push_back(u);
        G[u].push_back(v);
    }
    for (ll v = 0; v < n; v++) alive.insert(v);
    ll ans = -1;
    while (true) {
        if (alive.size() == 1) {
            ans = *alive.begin();
            break;
        }
        ll min_v = -1, min_max = INF;
        dfs(
                *alive.begin()
        );
        for (ll v : alive) if (D[v] < min_max) min_max = D[v], min_v = v;
        ll u = query(min_v);
        if (u == -1) {
            ans = min_v;
            break;
        }
        g_mark(min_v, u);
    }
    cout << "! " << ans + 1 << endl;
}
/*
9
1 2
3 1
3 4
3 5
5 6
5 7
5 8
8 9
 */