#include<bits/stdc++.h>

#define f first
#define s second
#define vec vector
#define pb push_back
#define sz(x) (int)(x).size()
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define all(x) (x).begin(), (x).end()
#define ld long double
#define pii pair<int, int>

using namespace std;
const int MAXN = 1e5 + 22;
const int INF = 2e9 + 15;
const int MAX = 30;

struct pt{
    ld x, y;

    pt ()
    {
        x = y = 0;
    }
};

ld dist(pt a, pt b)
{
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

const ld eps = 1e-12;

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vec<pt> a (n);
    for(auto &i : a)
        cin >> i.x >> i.y;

    auto calcsq = [&](pt a, pt b, pt c)
    {
        ld ab = dist(a, b);
        ld bc = dist(c, b);
        ld ca = dist(c, a);
        ld p = (ab + bc + ca) / 2;
        return sqrt(p * (p - ab) * (p - ca) * (p - bc));
    };

    auto in_triangle = [&](pt a, pt b, pt c, pt p)
    {
        ld sfull = calcsq(a, b, c);
        ld s1 = calcsq(a, b, p);
        ld s2 = calcsq(a, c, p);
        ld s3 = calcsq(b, c, p);

        if(abs(sfull - s1 - s2 - s3) <= eps)
            return 1;
        return 0;
    };

    auto check = [&](pt d)
    {
        for(int i = 2; i < n; i++)
        {
            if(in_triangle(a[0], a[1], a[i], d))
            {
                return 1;
            }
        }

        return 0;
    };

    int ans = 0;

    for(int x = 1; x < MAX; x++)
    {
        for(int y = 1; y < MAX; y++)
        {
            if(__gcd(x, y) == 1)
            {
                pt g;
                g.x = x;
                g.y = y;
                ans += check(g);
            }
        }
    }

    cout << ans;
}





