#include<bits/stdc++.h>

#define int long long
#define f first
#define s second
#define vec vector
#define pb push_back
#define sz(x) (int)(x).size()
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define all(x) (x).begin(), (x).end()
#define ld long double
#define pii pair<int, int>

using namespace std;
const int MAXN = 1e5 + 22;
const int INF = 2e9 + 15;
const int mod = 1e9 + 7;
const int p = 127;

int add(int a, int b)
{
    return ((long long)a + b) % mod;
}

int sub(int a, int b)
{
    if(a - b < 0)
        return a - b + mod;
    return a - b;
}

int mul(int a, int b)
{
    return ((long long)a * (long long)b) % mod;
}

signed main()
{
    int n, k, m;
    cin >> n >> k >> m;

    string alf;
    cin >> alf;

    vec<string> a (n);
    for(auto &i : a)
        cin >> i;

    vec<int> hashes (n);
    vec<int> dg (k + 1);
    int d = 1;

    FOR(i, k + 1)
    {
        dg[i] = d;
        d = mul(d, p);
    }

    FOR(i, n)
    {
        int h = 0;
        FOR(j, k)
        {
            h = add(h, mul(dg[j], a[i][j]));
        }
        hashes[i] = h;
    }

    auto delete_ch = [&](int h, char ch, int pos)
    {
        return sub(h, mul(dg[pos], ch));
    };

    auto add_ch = [&](int h, char ch, int pos)
    {
        return add(h, mul(dg[pos], ch));
    };

    unordered_map<int, int> mp;

    FOR(i, n)
    {
        FOR(pos, k)
        {
            int h = hashes[i];
            FOR(ch, m)
            {
                if(a[i][pos] == alf[ch]) continue;
                int nh = h;
                nh = delete_ch(nh, a[i][pos], pos);
                nh = add_ch(nh, alf[ch], pos);
                mp[nh]++;
            }
        }
        mp[hashes[i]]++;
    }

    FOR(i, n)
    {
        int ans = 0;
        string res;

        FOR(pos, k)
        {
            int h = hashes[i];
            FOR(ch, m)
            {
                if(a[i][pos] == alf[ch]) continue;
                int nh = h;
                nh = delete_ch(nh, a[i][pos], pos);
                nh = add_ch(nh, alf[ch], pos);
                int cnt = mp[nh];
                if(cnt == 1)
                {
                    ans++;
                    if(!sz(res))
                    {
                        string g = a[i];
                        g[pos] = alf[ch];
                        res = g;
                    }
                }
            }
        }

        int cnt = mp[hashes[i]];
        if(cnt == 1)
        {
            ans++;
            if(!sz(res))
            {
                string g = a[i];
                res = g;
            }
        }

        if(ans)
            cout << ans << ' ' << res << endl;
        else
            cout << ans << endl;
    }
}




