#include <iostream>
#include <set>
#include <vector>

std::vector<int> factor(int a)
{
    std::vector<int> ans = {a};
    int x = a;
    for (int i = 2; i <= a; ++i) {
	while (x % i == 0) {
	    x /= i;
	    ans.push_back(x);
	}
    }
    return ans;
}

int main()
{
    int n;
    std::cin >> n;
    for (int i = 0; i < n; ++i) {
	int a, b;
	std::cin >> a >> b;
	auto factorA = factor(a);
	auto factorB = factor(b);
	std::set<int> setB;
	for (int i: factorB) setB.insert(i);
	for (int i: factorA) {
	    if (setB.count(i)) {
		std::cout << i << '\n';
		break;
	    }
	}
    }
    return 0;
}

