#include <bits/stdc++.h>
using namespace std;

#define rep(i, a, b) for (int (i) = a; (i) < (b); ++(i))
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

template<typename T1, typename T2>
bool ckmin(T1& a, const T2& b) {
    return a > b && (a = b, true);
}

template<typename T1, typename T2>
bool ckmax(T1& a, const T2& b) {
    return a < b && (a = b, true);
}

struct exam {
    int fl, fr, sl, sr;
};

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(ios::failbit);

    int n, m;
    cin >> n >> m;

    vector<exam> es(n);
    set<pii> seg;
    rep(i, 0, n) {
        cin >> es[i].fl >> es[i].fr >> es[i].sl >> es[i].sr;
        seg.insert({es[i].fr, es[i].sl});
    }

    vector<pii> trav;
    rep(i, 0, m) {
        int l, r;
        cin >> l >> r;
        auto it = seg.lower_bound({l, r});
        if (it != seg.begin()) --it;

        bool good = true;
        rep(_, 0, 10) {
            if (it != seg.end()) {
                if (*it != pii{l, r} && it->first >= l && it->second <= r) good = false;
                it++;
            }
        }
        if (good) trav.emplace_back(l, r);
    }

    sort(all(trav), [&](const pii& a, const pii& b) {
        if (a.second - a.first != b.second - b.first) return a.second - a.first < b.second - b.first;
        return a < b;
    });

    auto isect = [](const pii& a, const pii& b) {
        return max(a.first, b.first) <= min(a.second, b.second);
    };

    set<array<int, 3>> exa;

    rep(i, 0, n) {
        exa.insert({es[i].fl, es[i].fr, i});
        exa.insert({es[i].sl, es[i].sr, i});
    }

    vi cnt(n, 2);
    int ans = 0;
    rep(i, 0, m) {
        auto it = exa.lower_bound({trav[i].first, trav[i].second, -1});
        if (it != exa.begin()) --it;

        bool ok = true;
        int cn = 0;
        while (it != exa.end() && cn++ < 10) {
            if (isect(trav[i], {(*it)[0], (*it)[1]}) && cnt[(*it)[2]] <= 1) {
                ok = false;
                break;
            }
            it++;
        }
        if (ok) {
            it = exa.lower_bound({trav[i].first, trav[i].second, -1});
            if (it != exa.begin()) --it;

            cn = 0;
            while (it != exa.end() && cn++ < 10) {
                if (isect(trav[i], {(*it)[0], (*it)[1]})) {
                    cnt[(*it)[2]]--;
                    exa.erase(it);
                    it = exa.lower_bound({trav[i].first, trav[i].second, -1});
                    if (it != exa.begin()) --it;
                    cn = 0;
                } else it++;
            }
            ans++;
        }
    }

    cout << ans << '\n';
}