#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <cmath>

typedef long long ll;

#define all(x) (x).begin(), (x).end()
#define pb(x) push_back(x)

using namespace std;


int main() {
    
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n; cin >> n;
    ll a, b;
    for (int _ = 0; _ < n; ++_) {
        cin >> a >> b;
        vector<ll> a_, b_;

        ll d = 2;
        ll b_t = b, a_t = a;
        while (d * d <= a_t) {
            while (a % d == 0) { a_.pb(d); a /= d; }
            ++d;
        }
        if (a != 1) a_.push_back(a);

        d = 2;
        while (d * d <= b_t) {
            while (b % d == 0) { b_.pb(d); b /= d; }
            ++d;
        }
        if (b != 1) b_.push_back(b);
        
        reverse(all(b_)); reverse(all(a_));
        
        ll res = 1;
        int i = 0, j = 0;
        while (i < a_.size() && j < b_.size() && a_[i] == b_[j]) {
            res *= a_[i];
            ++i; ++j;
        }
        cout << res << "\n";
    }
    
    return 0;
}
