#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <cmath>

typedef long long ll;

#define all(x) (x).begin(), (x).end()
#define pb(x) push_back(x)

using namespace std;


int main() {
    
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n; cin >> n;
    ll a, b;
    for (int _ = 0; _ < n; ++_) {
        cin >> a >> b;
        if (a > b) swap(a, b);
        vector<ll> a_, b_;
        map<ll, bool> mp;

        ll d = 2;
        ll b_t = b, a_t = a;
        mp[a] = true;
        while (d * d <= a_t) {
            while (a % d == 0) { a_.pb(d); a /= d; mp[a] = true; }
            ++d;
        }

        d = 2;
        bool f = false;
        if (mp[b]) { cout << b << "\n"; continue; }
        while (d * d <= b_t && !f) {
            while (b % d == 0) {
                b_.pb(d); b /= d; if (mp[b]) { cout << b << "\n"; f = true; break; }
            }
            if (f) break;
            ++d;
        }
        if (!f && mp[b]) { cout << b << "\n"; continue;}

        if (!f) cout << 1 << "\n";
    
        
    }
    
    return 0;
}
