#include<iostream>
#include <vector>
#include <string>
#include <math.h>
#include <algorithm>
#include <set>
#include <map>
using namespace std;
typedef long long ll;
int gcd(int x, int y) {
	return (y ? gcd(y, x % y) : x);
}
double check(double x1, double y1, double x2, double y2) {
	return x1 * y2 - x2 * y1;
}
signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	int n; cin >> n;
	vector <pair<double, double>> v(n);
	for (auto& i : v) cin >> i.first >> i.second;
	int res = 0;
	for (int x = 1; x <= 100; ++x) {
		for (int y = 1; y <= 100; ++y) {
			if (gcd(x, y) != 1) continue;
			int ok = 1;
			for (int j = 0; j < n; ++j) {
				ok *= check(v[(j + 1) % n].first - v[j].first, v[(j + 1) % n].second - v[j].second,
					x - v[j].first, y - v[j].second) >= 0;
			}
			res += ok;
		}
	}
	cout << res;
}