#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <string>
#include <deque>
#include <algorithm>
#include <iomanip>
#include <unordered_map>
#include <cmath>

using namespace std;

typedef long long ll;
const ll inf = 1e9;
const ll mod = 1e9 + 7;



int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	int n;
	cin >> n;
	map<int, int> m;
	if (n > 1e5) return 1;
	for (int i = 0; i != n - 1; i++) {
		int a, b;
		cin >> a >> b;
		if (b > a) m[a] = b;
		else m[b] = a;
	}
	if (n <= 20) {
		for (int i = 1; i != 21; i++) {
			cout << "? " << i << '\n';
			fflush(stdout);
			string s;
			cin >> s;
			if (s == to_string(0)) {
				cout << "! " << i;
				fflush(stdout);

				return 0;
			}
		}
	}
	vector <int> v(n);

	v[0] = 1;
	for (int i = 0; i != n - 1; i++) {
		v[i + 1] = m[v[i]];
	}
	int r = n - 1, l = 0;
	while (r - l != 1) {
		int to = (r + l) / 2;
		cout << "? " << v[to] << '\n';
		fflush(stdout);
		string s;
		cin >> s;
		if (s == to_string(0)) {
			cout << "! " << v[to];
			fflush(stdout);
			return 0;
		}
		if (to > 0 && s == to_string(v[to - 1])) {
			l = to;
		}
		else {
			r = to;
		}
	}
	cout << "? " << v[r] << '\n';
	fflush(stdout);

	string s;
	cin >> s;
	if (s == to_string(0)) {
		cout << "! " << v[r];
		fflush(stdout);
		return 0;
	}
	else {
		cout << "! " << v[l] ;
		fflush(stdout);
		return 0;
	}
}