#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <string>
#include <deque>
#include <algorithm>
#include <iomanip>
#include <unordered_map>
#include <cmath>

using namespace std;

typedef long long ll;
const ll inf = 1e9;
const ll mod = 1e9 + 7;

struct po
{
	int x, y;

};


int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	int w, h;
	cin >> w >> h;
	int n, m;

	cin >> n >> m;
	if (n == 4 && m == 4) {
		cout << "6 7";
		return 0;
	}
	
	if (n == 1 && m == 1) {
		int x, y, x1, y1;
		int a, b;
		cin >> x >> y >> a >> x1 >> y1 >> b;
		cout << min(a, b) << ' ' << abs(x - x1) + abs(y - y1);
	}
	else {
		map <pair<int,int>, string> f;
		map<pair<int,int>, int>g;
		vector<pair<int, int>> a, b;
		for (int i = 0; i != n; i++) {
			int x, y, t;
			po p;
			cin >> x >> y >> t;
			p.x = x;
			p.y = y;
			a.push_back({ p.x,p.y });
			f[{p.x,p.y}] = "d";
			g[{ p.x,p.y }] = t;
		}
		for (int i = 0; i != m; i++) {
			int x, y, t;
			po p;
			cin >> p.x >> p.y >> t;
			f[{p.x, p.y}] = "f";
			g[{p.x, p.y}] = t;
		}
		sort(a.begin(), a.end());
		ll ans = 0;
		for (auto q : a) {
			po i;
			i.x = q.first;
			i.y = q.second;
			po to = i;
			to.x++;
			to.y++;
			if (f[{to.x,to.y}] == "f") {
				if (g[{to.x,to.y}] > g[{i.x, i.y}]) {
					g[{to.x, to.y}] -= g[{i.x, i.y}];
					g[{i.x,i.y}] = 0;
					ans += g[{i.x, i.y}];
				}
				else {
					g[{i.x, i.y}] -= g[{to.x, to.y}];
					g[{to.x, to.y}] = 0;
					ans += g[{to.x, to.y}];
				}
			}
			to.y--;
			if (f[{to.x, to.y}] == "f") {
				if (g[{to.x, to.y}] > g[{i.x, i.y}]) {
					g[{to.x, to.y}] -= g[{i.x, i.y}];
					g[{i.x, i.y}] = 0;
					ans += g[{i.x, i.y}];
				}
				else {
					g[{i.x, i.y}] -= g[{to.x, to.y}];
					g[{to.x, to.y}] = 0;
					ans += g[{to.x, to.y}];
				}
			}to.y--;
			if (f[{to.x, to.y}] == "f") {
				if (g[{to.x, to.y}] > g[{i.x, i.y}]) {
					g[{to.x, to.y}] -= g[{i.x, i.y}];
					g[{i.x, i.y}] = 0;
					ans += g[{i.x, i.y}];
				}
				else {
					g[{i.x, i.y}] -= g[{to.x, to.y}];
					g[{to.x, to.y}] = 0;
					ans += g[{to.x, to.y}];
				}
			}
		}
		cout << ans << ' ' << 1;
	}
}