#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <ctime>
#include <random>
#include <bitset>
#include <iomanip>
#include <chrono>
#include <algorithm>
#include <queue>
#include <deque>

#include <ext/pb_ds/assoc_container.hpp> // РћР±С‰РёР№ С„Р°Р№Р».
#include <ext/pb_ds/tree_policy.hpp> // РЎРѕРґРµСЂР¶РёС‚ РєР»Р°СЃСЃ tree_order_statistics_node_update

using namespace std;
using namespace __gnu_pbds;

// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx,avx2,fma,tune=native")

typedef long long ll;
typedef long double ld;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define int int_fast32_t
#define trace(x) cout << #x << " = " << x << endl;
#define trace2(x, y) cout << #x << " = " << x << ' ' << #y << " = " << y << endl;
#define trace3(x, y, z) cout << #x << " = " << x << ' ' << #y << " = " << y << ' ' << #z << " = " << z << endl;
#define trace4(x, y, z, a) cout << #x << " = " << x << ' ' << #y << " = " << y << ' ' << #z << " = " << z << ' ' << #a << " = " << a << endl;
#define trace_name(x) cout << #x << " = ";
#define trace_all_in(x) cout << #x << " = "; for (auto i : x) cout << i << ' '; cout << endl;

mt19937 rnd(time(0));

const ll INF = (ll)(1e18);
const ll MOD = (ll)(1e9 + 7);  // 998244353; //
const ld EPS = (ld)(1e-10);
const ld PI = acos(-1);

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cout << fixed << setprecision(30);
}

template <typename T>
using ordered_set =  tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update>;

void solve() {
    ll n, m;
    cin >> n >> m;

    vector<vector<ll>> a(n, vector<ll> (4));
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < 4; ++j) cin >> a[i][j];
    }

    vector<ll> nach(m), kon(m);
    for (ll i = 0; i < m; ++i) {
        cin >> nach[i] >> kon[i];
    }

    vector<vector<ll>> dp(n, vector<ll> (2));
    dp[n - 1][1] = nach.end() - upper_bound(all(nach), a[n - 1][3]);
    dp[n - 1][0] = nach.end() - upper_bound(all(nach), a[ n - 1][1]);

    for (ll i = n - 2; i >= 0; --i) {
//        dp[i][0] = max(dp[i + 1][0], dp[i + 1][1]);
//        dp[i][1] = dp[i][0];
        if (true) {
            ll ind1 = upper_bound(all(nach), a[i][1]) - nach.begin();
            ll ind2 = lower_bound(all(kon), a[i + 1][0]) - kon.begin();
            dp[i][0] = max(dp[i][0], dp[i + 1][0] + ind2 - ind1);
        }
        if (true) {
            ll ind1 = upper_bound(all(nach), a[i][1]) - nach.begin();
            ll ind2 = lower_bound(all(kon), a[i + 1][2]) - kon.begin();
            dp[i][0] = max(dp[i][0], dp[i + 1][1] + ind2 - ind1);
        }
        if (true) {
            ll ind1 = upper_bound(all(nach), a[i][3]) - nach.begin();
            ll ind2 = lower_bound(all(kon), a[i + 1][0]) - kon.begin();
            dp[i][1] = max(dp[i][1], dp[i + 1][0] + ind2 - ind1);
        }
        if (true) {
            ll ind1 = upper_bound(all(nach), a[i][3]) - nach.begin();
            ll ind2 = lower_bound(all(kon), a[i + 1][2]) - kon.begin();
            dp[i][1] = max(dp[i][1], dp[i + 1][1] + ind2 - ind1);
        }
    }

//    for (auto i : dp) {
//        for (auto j : i) {
//            cout << j << ' ';
//        }
//        cout << '\n';
//    }

    cout << max(dp[0][0], dp[0][1]);
}

signed main() {
//    freopen("mountain.in", "r", stdin);
//    freopen("mountain.out", "w", stdout);

    fast_stream();

    int tests = 1;
//    cin >> tests;
    while (tests--) {
        solve();
    }
}

/*

0 1
0 0
1 0
0 -1

*/