#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <ctime>
#include <random>
#include <bitset>
#include <iomanip>
#include <chrono>
#include <algorithm>
#include <queue>
#include <deque>

#include <ext/pb_ds/assoc_container.hpp> // РћР±С‰РёР№ С„Р°Р№Р».
#include <ext/pb_ds/tree_policy.hpp> // РЎРѕРґРµСЂР¶РёС‚ РєР»Р°СЃСЃ tree_order_statistics_node_update

using namespace std;
using namespace __gnu_pbds;

// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx,avx2,fma,tune=native")

typedef long long ll;
typedef long double ld;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define int int_fast32_t
#define trace(x) cout << #x << " = " << x << endl;
#define trace2(x, y) cout << #x << " = " << x << ' ' << #y << " = " << y << endl;
#define trace3(x, y, z) cout << #x << " = " << x << ' ' << #y << " = " << y << ' ' << #z << " = " << z << endl;
#define trace4(x, y, z, a) cout << #x << " = " << x << ' ' << #y << " = " << y << ' ' << #z << " = " << z << ' ' << #a << " = " << a << endl;
#define trace_name(x) cout << #x << " = ";
#define trace_all_in(x) cout << #x << " = "; for (auto i : x) cout << i << ' '; cout << endl;

mt19937 rnd(time(0));

const ll INF = (ll)(1e18);
const ll MOD = (ll)(1e9 + 7);  // 998244353; //
const ld EPS = (ld)(1e-10);
const ld PI = acos(-1);

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cout << fixed << setprecision(30);
}

template <typename T>
using ordered_set =  tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update>;

void solve() {
    ll n, m, q;
    cin >> n >> m >> q;

    ll cnt_all = 0;
    map<ll, ll> on_pref;

    while (q--) {
        ll left, right;
        cin >> left >> right;
        --left, --right;

        ll ind1 = left / m, ind2 = right / m;

        if (ind1 == ind2) {
            on_pref[right % m]++;
            if (left % m) --on_pref[left % m - 1];
        }
        else {
            if (left % m) {
                ++on_pref[m - 1];
                --on_pref[left % m - 1];
                left /= m;
                ++left;
                left *= m;
            }

            if ((right + 1) % m) {
                ++on_pref[right % m];
                right -= right % m;
            }
            else ++right;

            cnt_all += (right - left) / m;
        }
    }

    vector<ll> h;
    for (auto i : on_pref) {
        h.push_back(i.second);
    }

    for (ll i = h.size() - 2; i >= 0; --i) {
        h[i] += h[i + 1];
    }

    ll mn = INF;

    for (auto i : h) mn = min(mn, i);

    cout << cnt_all + mn;
}

signed main() {
//    freopen("mountain.in", "r", stdin);
//    freopen("mountain.out", "w", stdout);

    fast_stream();

    int tests = 1;
    // cin >> tests;
    while (tests--) {
        solve();
    }
}

/*

0 1
0 0
1 0
0 -1

*/