//#pragma comment(linker, "/STACK:130000000")
#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <set>
using namespace std;

inline void start() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
}

const int N = 1e5 + 10;
int sl[N], sr[N], fl[N], fr[N], l[N], r[N];
unordered_set<int> q[N][2];
int val[N][2];

int main() {
	start();
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; i++)
		cin >> sl[i] >> sr[i] >> fl[i] >> fr[i];
	for (int i = 0; i < m; i++)
		cin >> l[i] >> r[i];
	int h = 0;
	for (int i = 0, j; i < n; i++) {
		j = h;
		while (r[j] < sl[i])
			j++;
		h = j;
		while (j < m && l[j] <= fr[i]) {
			if (!(r[j] < sl[i] || sr[i] < l[j]))
				q[i][0].insert(j);
			if (!(r[j] < fl[i] || fr[i] < l[j]))
				q[i][1].insert(j);
			j++;
		}
	}
	val[0][0] = q[0][0].size();
	val[0][1] = q[0][1].size();
	for (int i = 1; i < n; i++) {
		int v1 = 0, v2 = 0;
		for (int j : q[i][0]) {
			if (q[i - 1][0].find(j) == q[i - 1][0].end())
				v1++;
			if (q[i - 1][1].find(j) == q[i - 1][1].end())
				v2++;
		}
		val[i][0] = min(val[i - 1][0] + v1, val[i - 1][1] + v2);
		v1 = 0, v2 = 0;
		for (int j : q[i][1]) {
			if (q[i - 1][0].find(j) == q[i - 1][0].end())
				v1++;
			if (q[i - 1][1].find(j) == q[i - 1][1].end())
				v2++;
		}
		val[i][1] = min(val[i - 1][0] + v1, val[i - 1][1] + v2);
	}
	cout << m - min(val[n - 1][0], val[n - 1][1]);
	return 0;
}