//#pragma comment(linker, "/STACK:130000000")
#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
using namespace std;

inline void start() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
}

const int N = 1e4;
vector<int> prime;
bool notPrime[N];

void f() {
	for (int i = 2; i < N; i++)
		if (!notPrime[i]) {
			prime.push_back(i);
			for (int j = i * i; j < N; j += i)
				notPrime[j] = 1;
		}
}

int main() {
	start();
	f();
	int t;
	cin >> t;
	while (t--) {
		int a, b;
		map<int, int> qa, qb;
		cin >> a >> b;
		if (a > b)
			swap(a, b);
		for (int i = 0; i < (int)prime.size() && a > 1; i++)
			while (a % prime[i] == 0) {
				qa[prime[i]]++;
				a /= prime[i];
			}
		if (a > 1 || qa.empty())
			qa[a]++;
		for (int i = 0; i < (int)prime.size() && b > 1; i++)
			while (b % prime[i] == 0) {
				qb[prime[i]]++;
				b /= prime[i];
			}
		if (b > 1 || qb.empty())
			qb[b]++;
		if (qa.rbegin()->first != qb.rbegin()->first)
			cout << "1\n";
		else {
			long long ans = 1;
			int sz = qa.size();
			for (auto i = prev(qa.end()); sz &&
				qb[i->first] > 0; i--, sz--) {
				int s = min(i->second, qb[i->first]);
				for (int j = 0; j < s; j++)
					ans *= i->first;
			}
			cout << ans << '\n';
		}
	}
	return 0;
}