#pragma comment(linker, "/STACK:130000000")
#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <queue>
#include <unordered_set>
using namespace std;

inline void start() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
}

const int N = 1e4;
vector<int> prime;
bool notPrime[N];

void f() {
	for (int i = 2; i < N; i++)
		if (!notPrime[i]) {
			prime.push_back(i);
			for (int j = i * i; j < N; j += i)
				notPrime[j] = 1;
		}
}

int main() {
	start();
	f();
	int t;
	cin >> t;
	while (t--) {
		int a, b;
		long long ans = 1;
		cin >> a >> b;
		for (int i = prime.size() - 1; i >= 0; i--) {
			while (a % prime[i] == 0 && b % prime[i] == 0) {
				ans *= prime[i];
				a /= prime[i];
				b /= prime[i];
			}
			if (a % prime[i] == 0 ^ b % prime[i] == 0)
				break;
		}
		cout << ans << '\n';
	}
	return 0;
}