#include <bits/stdc++.h>
#define int long long
#ifdef LOCAL
#   define debug(x) cout << #x << " = " << (x) << endl
#else
#   define debug(x)
#endif

typedef long long ll;
typedef long double ld;
using namespace std;


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m; cin >> n >> m;

    int fl[n], fr[n], sl[n], sr[n];
    for (int i = 0; i < n; i++) {
        cin >> fl[i] >> fr[i] >> sl[i] >> sr[i];
    }

    int l[m], r[m];
    for (int i = 0; i < m; i++) {
        cin >> l[i] >> r[i];
    }

    int cntl[n]{}, cntr[n]{};

    deque<int> Q;
    int j = 0;
    for (int i = 0; i < n; i++) {
        while (j != m && l[j] <= fr[i]) {
            Q.push_back(j);
            j++;
        }
        while (!Q.empty() && r[Q.front()] < fl[i]) {
            Q.pop_front();
        }
        cntl[i] = Q.size();
    }

    Q.clear();
    j = 0;
    for (int i = 0; i < n; i++) {
        while (j != m && l[j] <= sr[i]) {
            Q.push_back(j);
            j++;
        }
        while (!Q.empty() && r[Q.front()] < sl[i]) {
            Q.pop_front();
        }
        cntr[i] = Q.size();
    }

    int ans = 0;
    for (int i = 0; i < n; i++) {
        ans += max(cntl[i], cntr[i]);
    }
    cout << ans;
    return 0;
}