#include <bits/stdc++.h>
#define int long long
#ifdef LOCAL
#   define debug(x) cout << #x << " = " << (x) << endl
#else
#   define debug(x)
#endif

typedef long long ll;
typedef long double ld;
using namespace std;

vector<int> g[200500];

unordered_map<int, int> quests;
int get(int u) {
    if (quests.find(u) != quests.end()) {
        return quests[u];
    }
    cout << u << endl;
    int v; cin >> v;

    if (v == 0) {
        cout << "! " << u << endl;
        exit(0);
    }
    else {
        quests[u] = v;
        return v;
    }
}

int sz[200500];
bool mark[200500];
void set_sz(int u, int p = -1) {
    sz[u] = 1;
    for (int v : g[u]) {
        if (!mark[v] && v != p) {
            set_sz(v, u);
            sz[u] += sz[v];
        }
    }
}

int centroid(int u, int N, int p = -1) {
    for (int v : g[u]) {
        if (v != p && sz[v] > N / 2 && !mark[v]) {
            return centroid(v, N, u);
        }
    }
    return u;
}

void dfs(int u, int N) {
    set_sz(u);
    u = centroid(u, N);

    mark[u] = true;
    int v = get(u);

    dfs(v, sz[v]);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n; cin >> n;
    for (int i = 1; i < n; i++) {
        int u, v; cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    dfs(1, n);
    return 0;
}