#include <bits/stdc++.h>
#define int long long
#ifdef LOCAL
#   define debug(x) cout << #x << " = " << (x) << endl
#else
#   define debug(x)
#endif

typedef long long ll;
typedef long double ld;
using namespace std;

const int p = 103;
const int mod = 1e9 + 7;

int bpow(int a, int b) {
    if (b == 0) {
        return 1;
    }

    if (b % 2 == 0) {
        int x = bpow(a, b / 2);
        return (x * x) % mod;
    }

    else {
        return (bpow(a, b - 1) * a) % mod;
    }
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k, alf_size;
    cin >> n >> k >> alf_size;

    string alf; cin >> alf;

    int pow[k + 1];
    pow[0] = 1;
    for (int i = 1; i <= k; i++) {
        pow[i] = (pow[i - 1] * p) % mod;
    }

    string A[n];
    for (auto &i : A) {
        cin >> i;
    }

    unordered_map<int, int> M[k];
    unordered_set<string> S;

    int del = bpow(p, mod - 2);
    for (string &s : A) {
        S.insert(s);
        int hash[k + 1];
        hash[0] = 0;
        for (int i = 1; i <= k; i++) {
            hash[i] = (hash[i - 1] + (s[i - 1] - 33) * p * pow[i]) % mod;
        }
        for (int i = 1; i <= k; i++) {
            int l = hash[i - 1];
            int r = hash[k] - hash[i];
            M[i - 1][(r * del + l) % mod]++;
        }
    }


    for (string &s : A) {
        int cnt = 0;
        string res;
        for (int i = 0; i < k; i++) {
            string c = s;
            for (char x : alf) {
                if (s[i] == x) continue;
                c[i] = x;

                int cnt2 = 0;

                int hash[k + 1];
                hash[0] = 0;
                for (int j = 1; j <= k; j++) {
                    hash[j] = (hash[j - 1] + (c[j - 1] - 33) * p * pow[j]) % mod;
                }
                for (int j = 1; j <= k; j++) {
                    int l = hash[j - 1];
                    int r = hash[k] - hash[j];
                    cnt2 += M[j - 1][(r * del + l) % mod];
                }
                cnt2 -= (k - 1) * (S.find(c) != S.end());
                if (cnt2 == 1) {
                    cnt++;
                    res = s;
                }
            }
        }
        int cnt2 = 0;
        for (int _i = 0; _i < k; _i++) {
            string cc = s;
            for (char y : alf) {
                if (y == s[_i]) continue;
                cc[_i] = y;
                cnt2 += (S.count(cc));
            }
        }
        cnt2 += (S.count(s));
        if (cnt2 == 1) {
            cnt++;
            res = s;
        }
        cout <<cnt << " " << res << "\n";
    }
    return 0;
}