#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <deque>
#include <queue>

#pragma GCC("Ofast")

using namespace std;
typedef int ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 2e9;
const ld EPS = 1e-9;
const ll MOD = 1000000000 + 7;
const ld PI = acos(-1);

bool q[10000000 + 20];

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n;
	cin >> n;
	while (n--) {
		ll a, b;
		cin >> a >> b;
    	if (a > b) swap(a, b);
		vector<ll> s = { a };
		ll i = 2;
		while (i * i <= a) {
			while (a % i == 0) {
				a /= i;
				s.push_back(a);
			}
			i++;
		}
		s.push_back(1);
		for (ll i = 0; i < s.size(); i++) {
			q[s[i]] = 1;
		}
		bool kk = 0;
		if (q[b]) {
			cout << b << "\n";
			kk = 1;
		}
		i = 2;
		while (i * i <= b && kk == 0) {
			while (b % i == 0) {
				b /= i;
				if (q[b]) {
					cout << b << "\n";
					kk = 1;
					break;
				}
			}
			i++;
		}
		if (!kk) cout << 1 << "\n";
		for (ll i = 0; i < s.size(); i++) {
			q[s[i]] = 0;
		}
	}
	return 0;
}