#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <deque>
#include <queue>
#include <unordered_set>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e18;
const ld EPS = 1e-9;
const ll MOD = 1000000000 + 7;
const ld PI = acos(-1);

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n, k, a;
	cin >> n >> k >> a;
	string alf;
	cin >> alf;
	vector<string> s(n);
	for (ll i = 0; i < n; i++) cin >> s[i];
	for (ll i = 0; i < n; i++) {
		set<string> p;
		for (ll j = 0; j < k; j++) {
			for (ll x = 0; x < a; x++) {
				string s1 = s[i];
				s1[j] = alf[x];
				p.insert(s1);
			}
		}
		for (ll j = 0; j < n; j++) {
			if (i == j) continue;
			if (i == 1 && j == 0) 
				ll aboba = 0;
			ll fir = -1, sec = -1;
			ll x = 0;
			for (ll l = 0; l < k; l++) {
				if (s[i][l] != s[j][l]) {
					if (fir == -1) fir = l;
					else sec = l;
					x++;
				}
			}
			if (x == 1) {
				for (ll x = 0; x < a; x++) {
					string s1 = s[i];
					s1[fir] = alf[x];
					p.erase(s1);
				}
			}
			else if (x == 2) {
				string s1 = s[i], s2 = s[i];
				s1[fir] = s[j][fir];
				s2[sec] = s[j][sec];
				p.erase(s1);
				p.erase(s2);
			}
		}
		cout << p.size() << " ";
		if (p.size() > 0) cout << *p.begin() << " ";
		cout << "\n";
	}
	return 0;
}