//#define _GLIBCXX_DEBUG

#include "iostream"
#include "vector"
#include "cassert"
#include "cmath"
#include "set"
#include "map"
#include "numeric"
#include "random"
#include "ctime"

#define check(x) cerr << (#x) << " = " << x << "\n"
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mkp make_pair
#define mkt make_tuple

using namespace std;

using ll = long long;

const int N = (int)1e4 + 7;
const int MOD = (int)1e9 + 7;
const int INF = (int)1e9 + 117;
const ll INFll = (ll)1e12 + 117;

template<class T> istream& operator>>(istream& in, vector<T>& v) {
    for (auto& i : v) in >> i;
    return in;
}

template<class T> ostream& operator<<(ostream& out, const vector<T>& v) {
    for (auto& i : v) out << i << " ";
    return out;
}

template<class T> inline void print(T* ar, int size_of_ar) {
    for (int i = 0; i < size_of_ar; ++i) cerr << ar[i] << " ";
    cerr << "\n";
}

int solve();

signed main() {
//#ifdef __WIN64__
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
//#endif
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	srand(34);
	int t = 1;
	//cin >> t;
	while (t--) assert(!solve());
}

char alph[94];

string v[N];
string tmp[17];

map<string, int> mp;

int ans[N]{};
string anss[N];

int solve() {
    int n, k, a;
    cin >> n >> k >> a;

    for (int i = 0; i < a; ++i) cin >> alph[i];

    for (int i = 0; i < n; ++i) {
        cin >> v[i];
        mp[v[i]]++;
        tmp = v[i];
        for (int j = 0; j < k; ++j) {
            for (int c = 0; c < a; ++c) {
                if (alph[c] != v[i][j]) {
                    tmp[j] = alph[c];
                    mp[tmp]++;
                }
            }
            tmp[j] = v[i][j];
        }
    }
    for (int i = 0; i < n; ++i) {
        tmp = v[i];

        if (mp[v[i]] <= 1) {
            ans[i]++;
            if (!anss[i].size()) anss[i] = v[i];
        }

        for (int j = 0; j < k; ++j) {
            for (int c = 0; c < a; ++c) {
                if (alph[c] != v[i][j]) {
                    tmp[j] = alph[c];
                    if (mp[tmp] <= 1) {
                        ans[i]++;
                        if (!anss[i].size()) anss[i] = tmp;
                    }
                }
            }
            tmp[j] = v[i][j];
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << ans[i] << " " << anss[i] << "\n";
    }

	return 0;
}
