#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <tuple>
#include <iomanip>
#include <string>
#include <cmath>
using namespace std;
vector<vector<int>>graph;
vector<int>level;
vector<int>vis;
void dfs(int start){
    vis[start] = true;
    for(auto val: graph[start]){
        if(!vis[val]){
            level[val] = level[start] + 1;
            dfs(val);
        }
    }
}
vector<int>mas;
void ans_dfs(int start, int last){
    int ans;
    if(last != -1 && graph[start].size() > 1 && graph[last].size() != 1){
        cout << start + 1 << "\n" << flush;
        cin >> ans;
        if(ans == 0){
            cout << "! " << start + 1 << "\n" << flush;
            exit(0);
        }
        else{
            ans_dfs(ans - 1, start);
        }
    }
    else if(last == -1 && graph[start].size() > 1){
        cout << start + 1 << "\n" << flush;
        cin >> ans;
        if(ans == 0){
            cout << "! " << start + 1 << "\n" << flush;
            exit(0);
        }
        else{
            ans_dfs(ans - 1, start);
        }
    }
    else{
        if(graph[start].size() == 1) {
            mas.push_back(start); ans_dfs(graph[start][0], start);
        }

        if(graph[start].size() != 1){
            cout << start + 1 << "\n" << flush;
            cin >> ans;
            if(ans == 0){
                cout << "! " << start + 1 << "\n" << flush;
                exit(0);
            }
            if(level[ans - 1] < level[start]){
                int left = 0;
                int right = mas.size();
                while(left + 1 < right){
                    int mid = (left + right) / 2;
                    cout << mas[mid] + 1 << "\n" << flush;
                    cin >> ans;
                    if(ans == 0){
                        cout << "! " << mas[mid] + 1 << "\n" << flush;
                        exit(0);
                    }
                    else{
                        if(level[ans - 1] < level[mas[mid]]){
                            right = mid;
                        }
                        else{
                            left = mid;
                        }
                    }
                }
                cout << mas[left] + 1 << "\n" << flush;
                cin >> ans;
                cout << "! " << mas[left] + 1 << "\n" << flush;
                exit(0);
            }
            else{
                ans_dfs(ans, start);
            }
        }
    }
}
int main() {
    int n;
    cin >> n;
    graph.resize(n);
    level.resize(n);
    vis.resize(n, false);
    for(int i = 0; i < n - 1; i++){
        int u, v;
        cin >> u >> v;
        graph[u - 1].push_back(v - 1);
    }
    level[0] = 0;
    dfs(0);
    ans_dfs(0, -1);
}
