#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <random>

using namespace std;

typedef long long ll;

mt19937 rnd('r' + 'o' + 'b' + 'i' + 'v' + 'i' + 'r' + 't');

// #define int ll

vector<int> t;

void update(int v, int l, int r, int idx, int x) {
	if (l + 1 == r) {
		t[v] = x;
		return;
	}
	int mid = (l + r) / 2;
	if (idx < mid) {
		update(2 * v + 1, l, mid, idx, x);
	}
	else {
		update(2 * v + 2, mid, r, idx, x);
	}
	t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

int get_max(int v, int l, int r, int a, int b) {
	if (b <= l || r <= a) {
		return 0;
	}
	if (a <= l && r <= b) {
		return t[v];
	}
	int mid = (l + r) / 2;
	return max(get_max(2 * v + 1, l, mid, a, b), get_max(2 * v + 2, mid, r, a, b));
}

signed main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	// pole chudes


	int n, m;
	cin >> n >> m;
	vector<pair<pair<int, int>, pair<int, int>>> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i].first.first >> arr[i].first.second >> arr[i].second.first >> arr[i].second.second;
	}
	vector<pair<int, int>> aaa;
	int gg = 0;
	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		int l = -1, r = n;
		while (l + 1 < r) {
			int mid = (l + r) / 2;
			if (arr[mid].first.second >= x) {
				r = mid;
			}
			else {
				l = mid;
			}
		}
		if (r == n || arr[r].second.first > y) {
			bool flag = true;
			for (int j = 0; j < n; j++) {
				if (arr[j].first.second < x && y < arr[j].second.first) {
					flag = false;
				} 
				if (true) {
					if (j == 0 && arr[j].first.first > y) {
						flag = false;
					}
					else if (j != 0 && arr[j].first.first > y && arr[j - 1].second.second < x) {
						flag = false;
					}
				}
				if (true) {
					if (j == n - 1 && arr[j].second.second < x) {
						flag = false;
					}
				}
			}
			if (flag) {
				aaa.push_back({ x, y });
			}
			else {
				gg++;
			}
		}
	}
	
	/*for (auto el : aaa) {
		cout << '?' << el.first << ' ' << el.second << '\n';
	} */
	m = aaa.size();
	if (m == 0) {
		cout << gg << '\n';
		return 0;
	}
	t.resize(4 * m);
	arr.insert(arr.begin(), { {-2, -2}, {-1, -1} });
	int j = 0;
	n++;
	vector<int> dp(m);
	for (int i = 0; i < m; i++) {
		int x = aaa[i].first, y = aaa[i].second;
		while (j + 1 < n && arr[j + 1].second.second < x) {
			j++;
		}
		if (j + 1 == n) {
			if (i == 0) {
				dp[i] = 1;
			}
			else {
				dp[i] = get_max(0, 0, m, 0, i) + 1;
			}
		}
		else {
			if (x <= arr[j + 1].first.first && arr[j + 1].first.first <= y || x <= arr[j + 1].first.second && arr[j + 1].first.second <= y || arr[j + 1].first.first <= x && y <= arr[j + 1].first.second) {
				if (i == 0) {
					dp[i] = 1;
				}
				else {
					dp[i] = get_max(0, 0, m, 0, i) + 1;
				}
			} 
			else {
				int l = -1, r = i;
				while (l + 1 < r) {
					int mid = (l + r) / 2;
					if (aaa[mid].second < arr[j + 1].first.first) {
						l = mid;
					}
					else {
						r = mid;
					}
				}
				if (l == -1) {
					dp[i] = 1;
				}
				else {
					dp[i] = get_max(0, 0, m, 0, l + 1) + 1;
				}
			}
		}
		update(0, 0, m, i, dp[i]);
	}
	/*for (int i = 0; i < m; i++) {
		cout << dp[i] << ' ';
	}
	cout << '\n';*/
	cout << *max_element(dp.begin(), dp.end()) + gg << '\n';


	return 0;
}