#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <deque>
#include <cmath>
#include <cassert>
#include <queue>

using namespace std;
typedef long long ll;

int n, m, q;

map <int, int> add;

const int inf = 1e9;
int mini = inf;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> m >> q;
	add[0] = 0;
	add[m] = 0;

	for (int i = 1; i <= q; ++i)
	{
		int l, r;
		cin >> l >> r;
		--l; --r;


		while (true)
		{
			int len = r - l + 1;

			if (r % m < l % m)
			{
				add[l % m]++;
				add[m]--;
				l = (l / m + 1) * m;
			}
			else if (len <= m)
			{
				add[l % m]++;
				add[r % m+ 1]--;
				break;
			}
			else if (l != 0)
			{
				add[l % m]++;
				add[m]--;
				l = (l / m + 1) * m;
			}
			else if (r% m < m - 1)
			{
				add[r% m]++;
				add[r % m + 1]--;
				add[0] += len / m;
				add[m] -= len / m;
				break;
			}
			else
			{
				add[0] += len / m;
				add[m] -= len / m;
				break;
			}
		}
	}

	int sum = 0;
	for (auto i : add)
	{
		sum += i.second;
		if (i.first < m) mini = min(mini, sum);

	}

	cout << mini;
	return 0;
}