#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <queue>
#include <random>
#include <bitset>
#include <algorithm>

#define ll long long
#define ld long double
#define ll int

using namespace std;

mt19937 rnd;

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    
    int n, m;
    cin >> n >> m;
    int q;
    cin >> q;
    int ans = 0;
    vector<pair<int, int>>a;
    vector<int>b;
    b.push_back(0);
    b.push_back(m - 1);
    for (int i = 0; i < q; ++i) {
        int l, r;
        cin >> l >> r;
        l -= 1;
        ans += (r - l) / m;
        l %= m;
        r %= m;
        if (l < r) {
            a.push_back({ l, r - 1 });
            b.push_back(l);
            b.push_back(r - 1);
            b.push_back(r);
        }
        else {
            if (r != l) {
                a.push_back({ l, m - 1 });
                a.push_back({ 0, r - 1 });
                b.push_back(l);
                if (r > 0) {
                    b.push_back(r - 1);
                    b.push_back(r);
                }
            }
        }
    }
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    while (b.back() == m) b.pop_back();
    int ans1 = 1e9;
    int inds = 0;
    int indf = 0;
    for (int i = 0; i < b.size(); ++i) {
        while (indf < a.size() && a[indf].first <= b[i]) {
            ++indf;
        }
        --indf;
        while (inds < a.size() && a[inds].second < b[i]) {
            ++inds;
        }
        ans1 = min(ans1, indf - inds + 1);
    }
    cout << ans + ans1;
    return 0;
}
