#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define sz(v) (int)v.size()
#define fastio ios_base::sync_with_stdio(false); cin.tie(NULL)

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

template<class T>
bool ckmin(T &a, const T &b) {
    if (b < a) {
        a = b;
        return true;
    }

    return false;
}

template<class T>
bool ckmax(T &a, const T &b) {
    if (b > a) {
        a = b;
        return true;
    }

    return false;
}

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const signed N = signed(1e7) + 100, MAXLOG = 20;

signed main() {
    fastio;

    int n, m, q; cin >> n >> m >> q;
    map<int, ll> add;

    while (q--) {
        ll l, r; cin >> l >> r;
        ll numberL = (l - 1) % m, numberR = (r - 1) % m;

        if (r - l + 1 <= m) {
            if (numberL <= numberR) {
                ++add[numberL];
                --add[numberR + 1];
            }
            else {
                ++add[numberL];
                ++add[0], --add[numberR + 1];
            }
        }
        else {
            ll needAdd = m - numberL, needSub = numberR + 1;
            ll i = l + needAdd, j = r - needSub;

            ++add[numberL];
            ++add[0], --add[numberR + 1];

            if (i <= j) {
                ll addition = (j - i + 1) / m;
                add[0] += addition;
            }
        }
    }

    ll balance = 0;
    ll minBalance = LINF;

    for (auto i : add) {
        if (i.first >= m) continue;
        balance += i.second;
        ckmin(minBalance, balance);
    }

    cout << minBalance;

    return 0;
}