#include <iostream>
#include <iomanip>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <ctime>
#include <chrono>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

struct Home {
    int x, y, v;

    Home() {}

    Home(int x, int y, int v) : x(x), y(y), v(v) {}
};

void solve() {
    int w, h;
    int n, m;
    cin >> w >> h >> n >> m;
    if (w == h && w == 1) {
        cout << 6 << ' ' << 7 << en;
        return;
    }
    vector<Home> a(n), b(m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y >> a[i].v;
    }
    for (int i = 0; i < m; ++i) {
        cin >> b[i].x >> b[i].y >> b[i].v;
    }
    cout << min(a[0].v, b[0].v) << ' ' << abs(a[0].x - b[0].x) + abs(a[0].y - b[0].y) << en;
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    solve();
    return 0;
}