#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
const int N = 1000000;
vector<long long> g[N];
bool used[N];
vector<long long> put;
void bin(vector<long long> p) {
	long long l = -1, r = p.size() + 1, m, a;
	while (r - 1 > l) {
		m = (l + r) / 2;
		cout << p[m] << "\n"; fflush(stdout);
		cin >> a;
		if (a == 0) {
			cout << "! " << p[m] << "\n";
			return;
		}
		else {
			if (a == p[m + 1]) {
				l = m;
			}
			else {
				r = m;
			}
		}
	}
}
void dfs(long long v) {
	used[v] = true;
	put.push_back(v);
	for (auto i : g[v]) {
		if (used[i] == false) {
			dfs(i);
		}
	}
}
int main() {
	long long n, a, b;
	cin >> n;
	for (int i = 0; i < n - 1; i++) {
		cin >> a >> b;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	for (int i = 0; i < n; i++) {
		if (g[i].size() == 1) {
			dfs(i);
			break;
		}
	}
	bin(put);
	return 0;
}