#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define all(x) (x).begin(), (x).end()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template <typename T>
inline int len(const T& x) {
    return x.size();
}

const int inf = 1e9 + 9;
const ll llinf = 1e18 + 9;
const ll MOD = 1e9 + 7;
const int maxN = 2e5 + 9;
vector<int> g[maxN];
vector<pii> ct[maxN];

int sz[maxN];
bool ranked[maxN];

void dfsz(int v, int p = -1) {
    sz[v] = 1;
    for(auto &i: g[v]) {
        if(i == p || ranked[i]) continue;
        dfsz(i, v);
        sz[v] += sz[i];
    }
}

int findc(int v, int totsz, int p = -1) {
    bool centro = true;
    for(auto &i: g[v]) {
        if(i == p || ranked[i]) continue;
        int res = findc(i, totsz, v);
        if(res != -1) return res;
        centro &= (sz[i] <= (totsz / 2));
    }

    if(p != -1) centro &= (totsz - sz[v]) <= (totsz / 2);
    if(centro) return v;
    return -1;
}
int root;
void goc(int v, int pc = -1) {
    dfsz(v);
    int oldv = v;
    v = findc(v, sz[v]);
    if(pc != -1) ct[pc].pb({oldv, v});
    else root = v;
    ranked[v] = true;

    for(auto &i: g[v]) {
        if(ranked[i]) continue;
        goc(i, v);
    }

}


int ask(int v) {
    cout << v << endl;
    int res; cin >> res;
    if(res == 0) {
        cout << "! " << v << endl;
        exit(0);
    }
    return res;
}


int main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int n; cin >> n;
    for(int i = 1; i < n; ++i) {
        int u, v; cin >> u >> v;
        g[u].pb(v);
        g[v].pb(u);
    }

    goc(1);

    int cv = root;
    while(true) {
        int x = ask(cv);
        for(auto &i: ct[cv]) {
            if(i.first == x) {
                cv = i.second;
                break;
            }
        }
    }

}
/*
7
1 2
2 3
3 4
4 5
5 6
6 7

 */