//#pragma GCC optimize("O3,no-stack-protector,unroll-loops,fast-math")
//#pragma GCC target("avx,avx2,fma,sse,sse2,sse3,sse4")
//#pragma comment(linker,"/STACK:4294967296")
#include<bits/stdc++.h>
using namespace std;
#define ff first
#define ss second
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define log(x) __lg(x)
#define gcd(a, b) __gcd(a, b)
typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<vpii> vvpii;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vpll> vvpll;
typedef vector<bool> vb;
const ll inf = 1e9+7;


#define debug 0

ll n, m;

ll f(ll &l, ll &r){
    ll l2 = l, r2 = r;

    l2 += ((m-l2)%m + m)%m;
    r2 -= r2%m;

    if(l/m != r/m){
        l %= m;
        r %= m;
        r += m;
    }
    else{
        l %= m;
        r %= m;
    }

    if(debug) cout << "f " << l2 << ' ' << r2 << '\n';

    return max(0ll, (r2-l2)/m);
}


int main(){
    if(!debug) ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int q;
    cin >> n >> m >> q;

    ll ans = 0;
    vll b(m);

    while(q--){
        ll l, r;
        cin >> l >> r;
        l--;
        r--;

        ans += f(l, r);

        for(ll i=l; i<=r; i++){
            b[i%m]++;
        }
    }

    ll add = inf;
    for(ll i=0; i<m; i++){
        add = min(add, b[i]);
    }

    ans += add;

    cout << ans << '\n';

    if(debug){
        for(int i=0; i<m; i++){
            cout << b[i] << ' ';
        }
        cout << '\n';
    }

    return 0;
}
