#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using namespace std;
#define ll long long
#define ull unsigned long long
#define fir first
#define sec second
#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front
#define SORT(v) sort(v.begin(), v.end())
#define REVERSE(v) reverse(v.begin(), v.end())

typedef tree<int, null_type, less<int>,
        rb_tree_tag, tree_order_statistics_node_update> indexed_set;

void solve(){
    int a, b;
    cin >> a >> b;
    vector <int> fa, fb;
    for (int d = 2; d * d <= max(a, b); d++){
        while (a % d == 0){
            a /= d;
            fa.pb(d);
        }
        while (b % d == 0){
            b /= d;
            fb.pb(d);
        }
    }
    if (a > 1) fa.pb(a);
    if (b > 1) fb.pb(b);
    SORT(fa);
    SORT(fb);
    int i = fa.size() - 1, j = fb.size() - 1, ans = 1;
    while (i > -1 && j > -1 && fa[i] == fb[j]){
        ans *= fa[i];
        i--;
        j--;
    }
    cout << ans << "\n";
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0),cout.tie(0);

    int t;
    cin >> t;
    while (t--){
        solve();
    }
}
