#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <cmath>
#include <cstdlib>

using namespace std;
#define int long long
//#pragma GCC optimize("O3")

int readi() {
    int x = 0;
    char c;
    c = getchar();
    bool m = false;
    if (c == '-') {
        m = true;
    }
    else {
        x = c - '0';
    }
    while ((c = getchar()) >= '0' && c <= '9') {
        x = x * 10 + (c - '0');
    }
    if (m) return -x;
    return x;
}

void outpi(int v) {
    if (v < 0) {
        putchar('-');
        v = -v;
    }
    if (v == 0) {
        putchar('0');
        return;
    }
    char buf[20];
    int l = 0;
    while (v) {
        buf[l++] = v % 10 + '0';
        v /= 10;
    }
    for (int i = l - 1; i >= 0; i--) putchar(buf[i]);
}

int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        if (a > b) {
            a %= b;
        }
        else {
            b %= a;
        }
    }
    return max(a, b);
}

void fct(int a, vector<int>& res) {
    int br = a;
    for (int i = 2; i * i <= br; i++) {
        while (a % i == 0) {
            a /= i;
            res.push_back(i);
        }
    }
    if (a != 1)
        res.push_back(a);
}

signed main() {
    int q = readi();
    if (q > 10) return 0;
    while (q--) {
        int a = readi();
        int b = readi();
        if (a == b) {
            outpi(a);
            putchar('\n');
            continue;
        }
        vector<int> path1 = { a };
        vector<int> path2 = { b };
        int br = a;
        for (int i = 2; i * i <= br; i++) {
            while (a % i == 0) {
                a /= i;
                path1.push_back(a);
            }
        }
        path1.push_back(1);

        br = b;
        for (int i = 2; i * i <= br; i++) {
            while (b % i == 0) {
                b /= i;
                path2.push_back(b);
            }
        }
        path2.push_back(1);
        int i1 = 0;
        int i2 = 0;
        int mx = 1;
        bool f = false;
        for (int i = 0; i < path1.size(); i++) {
            for (int j = 0; j < path2.size(); j++) {
                if (path1[i] == path2[j]) {
                    outpi(path1[i]);
                    f = true;
                    break;
                }
            }
            if (f) break;
        }
        if (!f) {
            putchar('1');
        }
        putchar('\n');
    }
    return 0;
}
