#pragma optimization ("Ofast")
#pragma target ("avx2")

#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

int n, u, v;
vector<vector<int>> g;
bool blocked[200010];

pair<int, int> getfurth(int x, int d, int p){
    pair<int, int> ans = {x, d}, k;
    for (int i : g[x]) {
        if (!blocked[i] && i != p) {
            k = getfurth(i, d + 1, x);
            if (k.second > ans.second) {
                ans = k;
            }
        }
    }
    return ans;
}

int ndist, aa;

bool getmid(int x, int targ, int dist, int p) {
    if (x == targ) {
        return true;
    }
    bool k;
    for (int i : g[x]) {
        if (!blocked[i] && i != p) {
            k = getmid(i, targ, dist + 1, x);
            if (k) {
                if (dist == ndist) {
                    aa = x;
                }
                return true;
            }
        }
    }
    return false;
}

int getdcentre(int beg) {
    int fp = getfurth(beg, 0, -1).first;
    pair<int, int> sp = getfurth(fp, 0, -1);
    ndist = sp.second / 2;
    aa = fp;
    getmid(fp, sp.first, 0, -1);
    return aa;
}

bool checkblock(int x) {
    for (int i : g[x]) {
        if (!blocked[i]) {
            return true;
        }
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    g.resize(n);
    for (int i = 1; i < n; ++i) {
        cin >> u >> v; --u; --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int pintree = 0, nex;
    while (1) {
        int fi = getdcentre(pintree);
        cout << fi + 1 << endl;
        cin >> nex; --nex;
        if (nex == -1) {
            cout << "! " << fi+1 << endl;
            break;
        }
        blocked[fi] = true;
        pintree = nex;
    }
}
