#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

struct point {
    long double x, y;
};

int gcd(int a, int b) {
    while (b != 0) {
        a = a % b;
        swap(a, b);
    }
    return a;
}

int scal(long double x0, long double y0, long double x1, long double y1, long double x2, long double y2) {
    long double v1x, v1y, v2x, v2y;
    v1x = x1 - x0;
    v1y = y1 - y0;
    v2x = x2 - x0;
    v2y = y2 - y0;
    long double ans = v1x * v2y - v1y * v2x;
    if (ans > 0) {
        return 1;
    }
    else if (ans == 0) {
        return 0;
    }
    else {
        return -1;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<point> a;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
    }
    bool poss;
    int ans = 0;
    for (int x = 1; x < 1000; ++x) {
        for (int y = 1; y < 1000; ++y) {
            if (gcd(x, y) != 1) continue;
            poss = true;
            for (int i = 0; i < n; ++i) {
                if (scal(a[i].x, a[i].y, a[(i+1)%n].x, a[(i + 1) % n].y, a[(i + 2) % n].x, a[(i + 2) % n].y) * scal(a[i].x, a[i].y, a[(i + 1) % n].x, a[(i + 1) % n].y, x, y) < 0) {
                    poss = false;
                    break;
                }
            }
            if (poss) {
                ++ans;
            }
        }
    }
    cout << ans;
}
