#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <string>

using namespace std;

typedef long long int ll;
typedef long double ld;

int main(){
    ios::sync_with_stdio(false);cin.tie(NULL);cout.tie(NULL);
    ll i = 2, j, lmt = 10000000;
    vector<int> div(lmt + 1, 1);
    while(i * i <= lmt){
        if(div[i] == 1){
            j = 2 * i;
            while(j <= lmt){
                div[j] = i;
                j += i;
            }
        }
        i += 1;
    }
    ll t, a, b, ans;
    cin >> t;
    while(t--){
        cin >> a >> b;
        set<int> p, q;
        p.insert(1);
        p.insert(a);
        q.insert(1);
        q.insert(b);
        vector<ll> v, u;
        while(div[a] != 1){
            v.push_back(div[a]);
            a /= div[a];
        }
        v.push_back(a);
        sort(v.begin(), v.end());

        while(div[b] != 1){
            u.push_back(div[b]);
            b /= div[b];
        }
        u.push_back(b);
        sort(u.begin(), u.end());

        for(ll i : v){
            p.insert(a / i);
            a /= i;
        }

        for(ll i : u){
            q.insert(b / i);
            b /= i;
        }

        ans = 1;
        for(ll d : p){
            if(q.count(d) > 0){
                ans = max(ans, d);
            }
        }
        cout << ans << "\n";
    }
    return 0;
}
