#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#include <ext/pb_ds/assoc_container.hpp>

//using namespace __gnu_pbds;
using namespace std;

//template<typename key, typename cmp = less<key>> using pbds = tree<key, null_type, cmp, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> a = {{0, 0}};
    for (int i = 1, l1, r1, l2, r2; i <= n; i++) {
        cin >> l1 >> r1 >> l2 >> r2;
        a.emplace_back(l1, r1);
        a.emplace_back(l2, r2);
    }
    a.emplace_back(INT64_MAX, INT64_MAX);
    vector<int> p(2 * n + 2);
    for (int i = 1, la, ra; i <= m; i++) {
        cin >> la >> ra;
        int l = 0, r = 2 * n + 1;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (la <= a[mid].second) r = mid;
            else l = mid;
        }
        p[r]++;
        l = 0, r = 2 * n + 1;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (ra < a[mid].first) r = mid;
            else l = mid;
        }
        p[l + 1]--;
    }
    int bal = 0;
    for (auto &i : p) {
        bal += i;
        i = bal;
//        cout << i << ' ';
    }
//    cout << '\n';
    int ans = m;
    for (int i = 1; i <= 2 * n; i += 2) ans -= min(p[i], p[i + 1]);
    cout << ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}
