#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

template<typename key, typename cmp = less<key>> using pbds = tree<key, null_type, cmp, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    for (int i = 1, v, u; i < n; i++) {
        cin >> v >> u, v--, u--;
        g[v].emplace_back(u);
        g[u].emplace_back(v);
    }
    vector<int> c;
    for (int v = 0; v < n; v++) {
        if (g[v].size() == 1) {
            c.emplace_back(v + 1);
            int u = g[v][0];
            while (g[u].size() != 1) {
                c.emplace_back(u + 1);
                if (g[u][0] != v) {
                    swap(g[u][0], g[u][1]);
                }
                v = u;
                u = g[v][1];
            }
            c.emplace_back(u + 1);
        }
    }
    int l = 0, r = n;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        cout << c[m] << endl;
        int ans;
        cin >> ans, ans--;
        if (ans == g[m][0]) {
            r = m;
        } else {
            l = m;
            if (ans == 0) break;
        }
    }
    cout << "! " << l << endl;
}

signed main() {
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);

    solve();

    return 0;
}
