#include <iostream>
#include <cmath>
#include <algorithm>
#include <memory.h>
#include <iomanip>
#include <string>
#include <sstream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <stack>
#include <deque>
#include <queue>
#include <random>
#include <stdio.h>
#include <ctime>
#include <chrono>
#define int long long
#define all(vc) vc.begin(), vc.end()
#define double long double
#define pii pair<int, int>
#define fir first
#define sec second
#define sp system("pause")
#define INF 1000000009
#define endl '/n'
using namespace std;

const int N = 1000007, MOD = 1e9 + 7, R = 1 << 19;

vector<int> tree(2 * R + 5, 0);
vector<int> flag(2 * R, 0);

void add1(int v)
{
	for (int i = 0; i < 2; i++)
	{
		flag[v * 2 + i] += flag[v];
		tree[v * 2 + i] += flag[v];
	}

	flag[v] = 0;
	return;
}

void change(int ql, int qr, int v, int nl, int nr, int add)
{
	if (nl >= ql && nr <= nr)
	{
		tree[v] += add;
		flag[v] += add;
		return;
	}

	if (nl > qr || nr < ql)
	{
		return;
	}

	add1(v);

	int nm = (nl + nr) / 2;

	change(ql, qr, 2 * v, nl, nm, add);
	change(ql, qr, 2 * v + 1, nm + 1, nr, add);

	tree[v] = min(tree[v * 2], tree[2 * v + 1]);
	return;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m, q;
	cin >> n >> m >> q;

	vector<pii> vc(q);

	for (int i = 0; i < m; i++)
	{
		tree[i + R] = 0;
	}

	for (int i = 0; i < q; i++)
	{
		cin >> vc[i].first >> vc[i].second;
		//vc[i].first--;
		//vc[i].second--;
	}

	vector<int> cnt(m);

	for (int i = 0; i < q; i++)
	{
		for (int j = vc[i].first; j <= vc[i].second; j++)
		{
			cnt[(j - 1) % m]++;
		}
	}

	int ans = INF;

	for (int i = 0; i < m; i++)
	{
		ans = min(ans, cnt[i]);
	}

	cout << ans;
	sp;
	return 0;
	/*for (int i = 0; i < q; i++)
	{
		int l = vc[i].first, r = vc[i].second;

		if (l % m != 0)
		{
			int r1 = l + m - (l % m) - 1;

			if (r1 <= r)
			{
				change((l%m) + 1, (r1%m) + 1, 1, 1, R, 1);
			}
		}

		if (r % m !=m-1)
		{
			int l1 = r - (r % m);

			if (l1 <= l)
			{
				change((l1%m) + 1, (r%m)+1, 1, 1, R, 1);
			}
		}

		r = r - (r % m) - 1;
		l = l +m - l % m;

		if (vc[i].first <= l && vc[i].second >= r && l <= r)
		{
			int add = (r - l) /m;

			change(1, m, 1, 1, R, add);
		}
	}

	cout << tree[1];*/
	sp;
	return 0;
}