#include <bits/stdc++.h>

using namespace std;

#define int long long

#define ff first
#define ss second

const int N = 1e7 + 5;

bool p[N] = {0};
unordered_set<int> st;

void solve() {
    int a, b;
    cin >> a >> b;
    unordered_map<int, int> mp;
    if (a == b) {
        cout << a << '\n';
        return;
    }
    if (st.find(a) != st.end() || st.find(b) != st.end()) {
        cout << 1 << '\n';
        return;
    }
    int d = 2;
    mp[a]++;
    mp[b]++;
    int p = 1;
    while (a > 1 && b > 1) {
        if (st.find(a) != st.end() && st.find(b) != st.end())
            break;
        while (a % d == 0) {
            mp[a / d]++;
            a /= d;
            if (mp[a] > 1)
                p = max(p, b);
            // cout << '%' << a << '\n';
        }
        while (b % d == 0) {
            mp[b / d]++;
            b /= d;
            if (mp[b] > 1)
                p = max(p, b);
            // cout << '/' << b << '\n';
        }
        d++;
    }
    cout << p << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    for (int i = 2; i <= N; i++) {
        if (p[i])
            continue;
        st.insert(i);
        for (int j = i * i; j <= N; j += i) {
            p[j] = 1;
        }
    }
    int _ = 1;
    cin >> _;
    for (; _; --_) {
        solve();
    }
}