#include <bits/stdc++.h>

using namespace std;

#define int long long

#define all(v) v.begin(), v.end()

const int N = 1e5 + 5;
const int INF = 1e18 + 5;

int t[4 * N];
int p[4 * N] = {0};

void psh(int w, int l, int r) {
    if (l + 1 != r) {
        p[2 * w + 1] += p[w];
        p[2 * w + 2] += p[w];
    }
    t[w] += p[w];
    p[w] = 0;
}

void upd(int w, int l, int r, int L, int R) {
    psh(w, l, r);
    if (r <= L || R <= l)
        return;
    if (L <= l && r <= R) {
        p[w]++;
        psh(w, l, r);
        return;
    }
    int m = (l + r) / 2;
    upd(2 * w + 1, l, m, L, R);
    upd(2 * w + 2, m, r, L, R);
    t[w] = min(t[2 * w + 1], t[2 * w + 2]);
}

int get(int w, int l, int r, int L, int R) {
    psh(w, l, r);
    if (r <= L || R <= l)
        return INF;
    if (L <= l && r <= R) {
        return t[w];
    }
    int m = (l + r) / 2;
    return min(get(2 * w + 1, l, m, L, R), get(2 * w + 2, m, r, L, R));
}

void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    // vector<int> v(m, 0);
    int ans = 0;
    for (; q; --q) {
        int l, r;
        cin >> l >> r;
        // if (l < m)
        l--;
        int a = l / m;
        int b = r / m;
        r -= b * m;
        l -= a * m;
        if (a < b) {
            ans += (b - a - 1); 
            upd(0, 0, m, l, m);
            upd(0, 0, m, 0, r);
        } else {
            upd(0, 0, m, l, r);
        }
        //cout << l << ' ' << r << '\n';
    }
    // for (int i = 0; i < m; i++) {
    //     cout << v[i] << ' ';
    // }
    // cout << '\n';
    // cout << t[0] << '\n';
    cout << ans + t[0];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int _ = 1;
    // cin >> _;
    for (; _; --_) {
        solve();
    }
}