#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define pb push_back
#define mp make_pair
#define fr first
#define sc second
#define all(arr) arr.begin(), arr.end()
#define rall(arr) arr.rbegin(), arr.rend()

int dp[100005][2];
vector<pair<int, int>> a, b;

pair<int, int> cover(int l, int r){
    int cl = 0, cr = b.size() - 1;
    int res_l, res_r;
    while(cl < cr){
        int cm = (cl + cr) / 2;
        if(b[cm].sc < l) cl = cm + 1;
        else cr = cm;
    }
    if(b[cl].sc < l) return mp(-1, -2);
    res_l = cl;

    cl = 0, cr = b.size() - 1;
    while(cl < cr){
        int cm = (cl + cr + 1) / 2;
        if(b[cm].fr > r) cr = cm - 1;
        else cl = cm;
    }
    if(b[cr].fr > r) return mp(-1, -2);
    res_r = cr;

    return mp(res_l, res_r);
}

int cov_cnt(int l, int r){
    pair<int, int> temp = cover(l, r);
    return temp.sc - temp.fr + 1;
}

int per(int l1, int r1, int l2, int r2){
    pair<int, int> seg1 = cover(l1, r1);
    pair<int, int> seg2 = cover(l2, r2);

    if(seg1.fr > seg1.sc || seg2.fr > seg2.sc) return 0;
    if(seg1.sc >= seg2.fr) return seg2.fr - seg1.sc;
    return 0;
}

void solve(){
    int n, m;
    cin >> n >> m;

    a.resize(2 * n), b.resize(m);
    for(auto &el: a)
        cin >> el.fr >> el.sc;
    for(auto &el: b)
        cin >> el.fr >> el.sc;

    dp[0][0] = cov_cnt(a[0].fr, a[0].sc);
    dp[0][1] = cov_cnt(a[1].fr, a[1].sc);
    for(int i = 1; i < n; ++i){
        dp[i][0] = min(cov_cnt(a[2 * i].fr, a[2 * i].sc) + dp[i - 1][0] - per(a[2 * (i - 1)].fr, a[2 * (i - 1)].sc, a[2 * i].fr, a[2 * i].sc),
                       cov_cnt(a[2 * i].fr, a[2 * i].sc) + dp[i - 1][1] - per(a[2 * (i - 1) + 1].fr, a[2 * (i - 1) + 1].sc, a[2 * i].fr, a[2 * i].sc));
        dp[i][1] = min(cov_cnt(a[2 * i + 1].fr, a[2 * i + 1].sc) + dp[i - 1][0] - per(a[2 * (i - 1)].fr, a[2 * (i - 1)].sc, a[2 * i + 1].fr, a[2 * i + 1].sc),
                       cov_cnt(a[2 * i + 1].fr, a[2 * i + 1].sc) + dp[i - 1][1] - per(a[2 * (i - 1) + 1].fr, a[2 * (i - 1) + 1].sc, a[2 * i + 1].fr, a[2 * i + 1].sc));
    }

    cout << m - min(dp[n - 1][0], dp[n - 1][1]) << '\n';
}

int main(){
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int tt = 1;
//    cin >> tt;

    while(tt--) solve();

    return 0;
}
