#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <map>

using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m; cin >> n >> m;
    vector<pair<int, int>> f(n), s(n);
    vector<pair<int, int>> ot(m);
    for (int i = 0; i < n; i++) {
        cin >> f[i].first >> f[i].second;
        cin >> s[i].first >> s[i].second;
    }
    for (int i = 0; i < m; i++)
        cin >> ot[i].first >> ot[i].second;
    int ans = m;
    int l = 0, cnt1, cnt2;
    for (int i = 0; i < n; i++) {
        cnt1 = 0, cnt2 = 0;
        while (l < m && ot[l].first < f[i].first)
            l++;
        while (l < m && ot[l].first <= f[i].second) {
            l++;
            cnt1++;
        }
        while (l < m && ot[l].first < s[i].first)
            l++;
        while (l < m && ot[l].first <= s[i].second) {
            l++;
            cnt2++;
        }
        ans -= min(cnt1, cnt2);
    }
    cout << ans;
    return 0;
}