#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <time.h>
#include <random>
#include <chrono>
#include <stdio.h>
#include <cstdio>
#include <map>
#include <algorithm>
#include <deque>
#include <numeric>
#include <memory>

using namespace std;
#define len(v) (int)(v).size()
#define ll long long
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define make_pair(u, v) mp(i,v)

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

inline void read(vector<int> &a) {
    for (auto &i : a)cin >> i;
}

//#define int long long

bool ok(int a, int b) {
    if (a % b != 0 && b % a != 0) return 0;
    int mx = 0;
    for (int i = 1; i * i <= a; ++i) {
        if (a % i == 0) {
            mx = max(i, mx);
            if (a / i != a) mx = max(mx, a / i);

            if (b < mx) break;
        }
    }
    if (mx == b) return 1;
    mx = 0;
    for (int i = 1; i * i <= b; ++i) {
        if (b % i == 0) {
            mx = max(i, mx);
            if (b / i != b) mx = max(mx, b / i);
            if (a < mx) break;
        }
    }
    return a == mx;
}

vector<vector<int>> g;

int ans = 0;
map<int,int> used;

void dfs(int u, int r, vector<int> way) {
    if (ans != 0 && ans != 1) return;
    used[u] = 1;
    way.emplace_back(u);
    //if (r * 2 < u) return;
    if (u == r) {
        ans = max(ans, *min_element(all(way)));
        return;
    }
    for (auto &to : g[u]) {
        if (!used[to]) {
            dfs(to, r, way);
        }
    }
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //freopen("input.txt","r",stdin);
    //freopen("output.txt","w",stdout);
    int n;
    cin >> n;
    ok(1, 2);
    g.resize(1e5+10);
    for (int i = 1; i <= 1e5; i++) {
        for (int j = i; j <= 1e5; j+=i) {
            if (ok(i, j)) {
                g[i].emplace_back(j);
                g[j].emplace_back(i);
            }
        }
    }

//    vector<int> prime(1e7 + 10, 1);
//    prime[0] = prime[1] = 0;
//    for (int i = 2; i < 1e7 + 10; ++i) {
//        if (!prime[i]) continue;
//        for (int j = i * i; j < 1e7 + 10; j += i) {
//            prime[j] = 0;
//        }
//    }

    while (n--) {
        int l, r;
        cin >> l >> r;
        if (gcd(l,r) == 1){
            cout << 1 << "\n";
            continue;
        }
        if (l == r){
            cout << l << "\n";
            continue;
        }
        used.clear();
        ans = 0;
        vector<int> a;
        dfs(l, r, a);
        if (ans == 0) ans = -1;
        cout << ans << "\n";
    }
    while (n--){
        int x;
        cin >> x;
        for (int i = 1;i <= 1000;++i){
            if (ok(i,x)) cout << i << " ";
        }
        cout << "\n";
    }
    return 0;
}
