#pragma GCC optimize("O3,unroll-loops,fast-math")
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <random>
using namespace std;
typedef long long ll;
const int INF = 1e9 + 7;
const ll LLINF = 2e18 + 13;
mt19937 rng;
uniform_int_distribution<int> uid(0, INF-1);
template<typename T>void smin(T&a,T b) {if(b<a)a=b;}
template<typename T>void smax(T&a,T b) {if(b>a)a=b;}

const int N = 1e7 + 3;
int hd[N];
int sieveSz;
int sieve[3163];
bool _sv[3163];
void cnt(int n) {
  int lst = 1;
  for (int i = 0; i < sieveSz && sieve[i] * sieve[i] < n; ++i) {
    int del = sieve[i];
    if (n % del == 0) {
      n /= del;
      lst = del;
      while (n % del == 0) {
        n /= del;
      }
    }
  }
  if (lst != 1 && n > 1) lst = n;
  hd[n] = lst;
}

int32_t main() {
  ios_base::sync_with_stdio(0); cin.tie(0);

  for (int i = 2; i < 3163; ++i) {
    if (_sv[i]) continue;
    sieve[sieveSz++] = i;
    for (int j = i * i; j < 3163; j += i) _sv[j] = true;
  }
  int n;
  cin >> n;
  while (n--) {
    int a,b;
    cin >> a >> b;
    set<int> st;
    while (a > 1) {
      st.insert(a);
      if (!hd[a]) cnt(a);
      a = hd[a];
    }
    int res = 1;
    while (b > 1) {
      if (st.count(b)) {
        res = b;
        break;
      }
      if (!hd[b]) cnt(b);
      b = hd[b];
    }
    cout << res << endl;
  }

  return 0;
}
